(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    231192,       4280]
NotebookOptionsPosition[    228319,       4222]
NotebookOutlinePosition[    228662,       4237]
CellTagsIndexPosition[    228619,       4234]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"KdV", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"x", ",", "t"}], "]"}], ",", "t"}], "]"}], "+", 
     RowBox[{"6", " ", 
      RowBox[{"u", "[", 
       RowBox[{"x", ",", "t"}], "]"}], "*", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{"x", ",", "t"}], "]"}], ",", "x"}], "]"}]}], "+", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"x", ",", "t"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "3"}], "}"}]}], "]"}]}], "\[Equal]", 
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], 
     RowBox[{"Cos", "[", "t", "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.757825829557377*^9, 3.757825837060305*^9}, {
   3.757826021150221*^9, 3.7578260229006853`*^9}, 3.757847515153267*^9, {
   3.762066536675339*^9, 3.762066541634609*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"05fe114f-2e97-4336-8c91-25a6faad9606"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"0", ",", "1"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"x", ",", "t"}], "]"}], "+", 
    RowBox[{"6", " ", 
     RowBox[{"u", "[", 
      RowBox[{"x", ",", "t"}], "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"x", ",", "t"}], "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"3", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"x", ",", "t"}], "]"}]}], "\[Equal]", 
   RowBox[{
    RowBox[{"Cos", "[", "t", "]"}], " ", 
    RowBox[{"Sin", "[", "x", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.7620666250692835`*^9, 3.842327983358254*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"12c66b72-71f4-4222-b4ef-1e57f5ffcb9c"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a1", ",", "a2", ",", "a3"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"b1", ",", "b2", ",", "b3"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"r1", ",", "r2"}], "}"}], "=", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7620664419647636`*^9, 3.7620665055072517`*^9}, {
  3.762066597018998*^9, 3.7620665980422463`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"4dd8ad5a-5571-4848-b895-7143003f1c98"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bc1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"a1", " ", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"u", "[", 
          RowBox[{"x", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "2"}], "}"}]}], "]"}], "/.", 
       RowBox[{"x", "\[Rule]", "0"}]}], ")"}]}], "+", 
    RowBox[{"a2", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"u", "[", 
          RowBox[{"x", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "1"}], "}"}]}], "]"}], "/.", 
       RowBox[{"x", "\[Rule]", "0"}]}], ")"}]}], "+", 
    RowBox[{"a3", " ", 
     RowBox[{"u", "[", 
      RowBox[{"0", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]}]], "Input",
 CellChangeTimes->{{3.7620661473553133`*^9, 3.762066290594482*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"67bc938c-5a76-4381-95e5-8b69c82c6727"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"0", ",", "t"}], "]"}], "+", 
   RowBox[{"2", " ", 
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"0", ",", "t"}], "]"}]}], "+", 
   RowBox[{
    SuperscriptBox["u", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"2", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"0", ",", "t"}], "]"}]}], "\[Equal]", "0"}]], "Output",
 CellChangeTimes->{{3.7620662429171286`*^9, 3.7620662910196066`*^9}, 
   3.762066615308728*^9, 3.8423279835732822`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"7beb0a4c-b0fe-4cb8-a9a2-17e9f38a68b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bc2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"b1", " ", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"u", "[", 
          RowBox[{"x", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "2"}], "}"}]}], "]"}], "/.", 
       RowBox[{"x", "\[Rule]", "1"}]}], ")"}]}], "+", 
    RowBox[{"b2", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"u", "[", 
          RowBox[{"x", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "1"}], "}"}]}], "]"}], "/.", 
       RowBox[{"x", "\[Rule]", "1"}]}], ")"}]}], "+", 
    RowBox[{"b3", " ", 
     RowBox[{"u", "[", 
      RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]}]], "Input",
 CellChangeTimes->{{3.762066292595984*^9, 3.7620663180906167`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"33a8a6ee-52c9-4d21-9ddc-a089614b0896"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"3", " ", 
    RowBox[{"u", "[", 
     RowBox[{"1", ",", "t"}], "]"}]}], "+", 
   RowBox[{
    SuperscriptBox["u", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"1", ",", "t"}], "]"}], "+", 
   RowBox[{"2", " ", 
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"2", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]], "Output",
 CellChangeTimes->{3.762066318536743*^9, 3.7620666138043604`*^9, 
  3.842327983625283*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"3b2c054f-a999-4bb8-a4f4-9b12c55ed55e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bc3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"r1", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"u", "[", 
          RowBox[{"x", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "1"}], "}"}]}], "]"}], "/.", 
       RowBox[{"x", "\[Rule]", "1"}]}], ")"}]}], "+", 
    RowBox[{"r2", "*", 
     RowBox[{"u", "[", 
      RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]}]], "Input",
 CellChangeTimes->{{3.7620663719545956`*^9, 3.762066384049716*^9}, {
  3.7620665627230988`*^9, 3.762066595178521*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"c6777c41-1163-4efd-882a-c0137430c7d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"5", " ", 
    RowBox[{"u", "[", 
     RowBox[{"1", ",", "t"}], "]"}]}], "+", 
   RowBox[{"5", " ", 
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]], "Output",
 CellChangeTimes->{3.762066384452837*^9, 3.76206656853959*^9, 
  3.762066601625224*^9, 3.8423279836762724`*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"99c14594-e8bd-4fac-85fc-9646df150c1a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bc", "=", 
  RowBox[{"{", 
   RowBox[{"bc1", ",", "bc2", ",", "bc3"}], "}"}]}]], "Input",
 CellChangeTimes->{
  3.757825865330798*^9, {3.757825910859918*^9, 3.7578259490760674`*^9}, {
   3.757826085677365*^9, 3.757826086092456*^9}, 3.7578262683338785`*^9, {
   3.7578262996862283`*^9, 3.7578262997582283`*^9}, {3.757842370435296*^9, 
   3.757842375562639*^9}, {3.75784242076365*^9, 3.757842427403414*^9}, 
   3.7578425942927732`*^9, 3.757842645823448*^9, 3.7578428015688477`*^9, {
   3.757842911521068*^9, 3.757842914854952*^9}, 3.7578429559378643`*^9, {
   3.7578436236052494`*^9, 3.7578436410438833`*^9}, {3.7591473927037697`*^9, 
   3.759147396757507*^9}, {3.7591474396044064`*^9, 3.7591474405910788`*^9}, {
   3.759147482713702*^9, 3.759147500658885*^9}, 3.7591475323359375`*^9, {
   3.759147673629114*^9, 3.759147675564624*^9}, {3.759147824825486*^9, 
   3.7591478322430377`*^9}, {3.7591482603832865`*^9, 3.7591482821218367`*^9}, 
   3.759148324586752*^9, {3.759148356805262*^9, 3.759148387201191*^9}, 
   3.7591484399522047`*^9, 3.75914847460553*^9, {3.7591485073870025`*^9, 
   3.759148533571997*^9}, 3.75914856367047*^9, {3.759148628808507*^9, 
   3.759148634181297*^9}, {3.7591486867839355`*^9, 3.759148708840065*^9}, {
   3.7620628015910983`*^9, 3.7620628057111692`*^9}, {3.762062953527525*^9, 
   3.7620629567193527`*^9}, {3.7620633388235083`*^9, 3.7620634026950645`*^9}, 
   3.7620634598009024`*^9, 3.762063557383206*^9, {3.7620635959762387`*^9, 
   3.7620636996491423`*^9}, {3.76206373544143*^9, 3.762063757849245*^9}, {
   3.7620637908518076`*^9, 3.7620638466572886`*^9}, 3.7620638777773666`*^9, 
   3.7620639614170704`*^9, 3.762063995511917*^9, 3.7620640656321135`*^9, {
   3.7620641847690306`*^9, 3.762064185591241*^9}, 3.7620642268809576`*^9, 
   3.7620643183526936`*^9, {3.7620643559204426`*^9, 3.7620644491606383`*^9}, {
   3.7620645210412893`*^9, 3.7620645733518457`*^9}, {3.7620646371544037`*^9, 
   3.7620646742420263`*^9}, 3.762064708995063*^9, {3.7620651309945707`*^9, 
   3.7620651438248997`*^9}, 3.762065222026193*^9, 3.762065350850623*^9, {
   3.7620654354185677`*^9, 3.762065447097598*^9}, {3.762066388450878*^9, 
   3.762066394042327*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"9e589859-453d-4860-8f81-475891e17d49"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"0", ",", "t"}], "]"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       SuperscriptBox["u", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"0", ",", "t"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["u", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"2", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"0", ",", "t"}], "]"}]}], "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"3", " ", 
      RowBox[{"u", "[", 
       RowBox[{"1", ",", "t"}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["u", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"1", ",", "t"}], "]"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{
       SuperscriptBox["u", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"2", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"5", " ", 
      RowBox[{"u", "[", 
       RowBox[{"1", ",", "t"}], "]"}]}], "+", 
     RowBox[{"5", " ", 
      RowBox[{
       SuperscriptBox["u", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7620644298386297`*^9, 3.7620644498337955`*^9}, {
   3.7620645235969353`*^9, 3.762064573804964*^9}, {3.7620646378105974`*^9, 
   3.7620646748131948`*^9}, 3.7620647100133276`*^9, 3.7620649338464108`*^9, {
   3.7620651444900827`*^9, 3.762065149814438*^9}, 3.7620652229574165`*^9, 
   3.7620653519669113`*^9, 3.762065451386695*^9, 3.762066394347406*^9, 
   3.762066618642601*^9, 3.842327983731287*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"52db2240-a8b9-479f-8ad1-91dfa5b24d18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["bc3"], "Input",
 CellChangeTimes->{{3.762066581949071*^9, 3.7620665847218065`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"c76a3740-7723-4cb8-be19-726e2b8030c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"5", " ", 
    RowBox[{"u", "[", 
     RowBox[{"1", ",", "t"}], "]"}]}], "+", 
   RowBox[{"5", " ", 
    RowBox[{
     SuperscriptBox["u", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"1", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"1", ",", "t"}], "]"}]}]}], "\[Equal]", "0"}]], "Output",
 CellChangeTimes->{{3.7620665852429266`*^9, 3.7620666049130287`*^9}, 
   3.842327983801282*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"cff52420-edc0-478d-9244-a2a4b0af3940"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ic", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{"x", ",", "0"}], "]"}], "\[Equal]", "0"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7578259590947137`*^9, 3.757825980564437*^9}, {
   3.757826249384844*^9, 3.7578262557415648`*^9}, {3.7578423599714966`*^9, 
   3.757842361602949*^9}, 3.7578426536795597`*^9, {3.7578429064266925`*^9, 
   3.7578429364636726`*^9}, {3.757843616582406*^9, 3.757843619452164*^9}, {
   3.75914740356341*^9, 3.7591474098293433`*^9}, {3.759147589774123*^9, 
   3.7591475935641336`*^9}, {3.7591480088557215`*^9, 
   3.7591480104296923`*^9}, {3.759148084025695*^9, 3.7591481564030495`*^9}, {
   3.7591482075749664`*^9, 3.7591482094417253`*^9}, 3.7591482430412645`*^9, {
   3.7591483079342136`*^9, 3.7591483118680124`*^9}, {3.7591483664441605`*^9, 
   3.7591483688499746`*^9}, {3.759148445930814*^9, 3.7591484463955545`*^9}, {
   3.7591484843689003`*^9, 3.7591485183132286`*^9}, 3.7591485508369827`*^9, {
   3.7591486727444525`*^9, 3.7591487011843305`*^9}, {3.762062965278558*^9, 
   3.762062993311869*^9}, 3.7620630502566333`*^9, 3.7620633441438904`*^9, 
   3.762063550271377*^9, {3.762063604936565*^9, 3.762063612183445*^9}, {
   3.7620636688801594`*^9, 3.762063747535568*^9}, {3.7620638094406333`*^9, 
   3.7620638692891645`*^9}, {3.762063910240791*^9, 3.7620640121592484`*^9}, {
   3.7620642040250263`*^9, 3.7620642074799223`*^9}, 3.762064313984559*^9, {
   3.762064477080883*^9, 3.762064477391947*^9}, 3.7620653811934958`*^9, 
   3.7620654772584243`*^9, 3.76206602249191*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"7da20787-52c3-4bad-b963-ec44d4166781"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"x", ",", "0"}], "]"}], "\[Equal]", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7578259827990093`*^9, 3.7578260923351164`*^9, 3.757826258540301*^9, 
   3.7578263032871675`*^9, 3.7578423785604362`*^9, 3.75784265493487*^9, {
   3.757842908161169*^9, 3.7578429369838114`*^9}, 3.7578436435955772`*^9, 
   3.759131449305073*^9, 3.75914741038718*^9, 3.759147446396656*^9, {
   3.7591474862137423`*^9, 3.759147503457258*^9}, 3.7591475348879547`*^9, 
   3.7591475960487976`*^9, 3.7591476781213074`*^9, {3.7591480167333827`*^9, 
   3.7591480277933254`*^9}, 3.7591480895545416`*^9, {3.7591481240229025`*^9, 
   3.7591481764068074`*^9}, 3.759148210325427*^9, {3.759148244105443*^9, 
   3.759148312527596*^9}, {3.7591483591366205`*^9, 3.7591483892149515`*^9}, {
   3.759148446770583*^9, 3.759148458821574*^9}, {3.7591484957777033`*^9, 
   3.7591485550734463`*^9}, 3.7591486387308493`*^9, {3.7591486750744276`*^9, 
   3.7591487016062365`*^9}, 3.7597357868599215`*^9, 3.759735860267994*^9, 
   3.760700661980223*^9, 3.7607631899489837`*^9, 3.7607633804270496`*^9, {
   3.762062981894869*^9, 3.762062994176083*^9}, 3.762063051459937*^9, {
   3.762063344875078*^9, 3.762063353978423*^9}, 3.7620634128216934`*^9, {
   3.762063551337636*^9, 3.7620635608781385`*^9}, 3.7620636136928186`*^9, {
   3.7620636696423597`*^9, 3.7620637685750265`*^9}, {3.76206381139514*^9, 
   3.762063887219797*^9}, {3.7620639382190485`*^9, 3.7620640180517483`*^9}, 
   3.7620640758127384`*^9, {3.7620641892662034`*^9, 3.7620642079270444`*^9}, 
   3.762064314521696*^9, 3.7620643920728292`*^9, {3.7620644508550606`*^9, 
   3.7620644783242044`*^9}, 3.762064556527482*^9, 3.762064640017172*^9, 
   3.762064711301644*^9, 3.7620649352277765`*^9, {3.762065354115452*^9, 
   3.7620653826728644`*^9}, {3.762065452624031*^9, 3.762065478077634*^9}, 
   3.762066507723834*^9, 3.7620666063414345`*^9, 3.8423279838562865`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"4d13341e-ba83-4262-96f5-c04871fcf7a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"usol", "=", 
  RowBox[{"First", "[", 
   RowBox[{"u", "/.", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"KdV", ",", "bc", ",", "ic"}], "}"}], "]"}], ",", "u", ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.757842230386078*^9, 3.757842280498396*^9}, {
   3.7578424698207035`*^9, 3.7578424896439686`*^9}, {3.7578425429001217`*^9, 
   3.757842544574547*^9}, {3.757842670805104*^9, 3.7578427097504525`*^9}, {
   3.7578427447747602`*^9, 3.757842754005193*^9}, {3.757843700437682*^9, 
   3.757843719693781*^9}, {3.7578437523344536`*^9, 3.757843771382531*^9}, {
   3.7578438931048765`*^9, 3.757843977358246*^9}, {3.7591473794639077`*^9, 
   3.7591473827787695`*^9}, {3.7591480554114733`*^9, 
   3.7591480564656906`*^9}, {3.759148188885408*^9, 3.759148194246818*^9}, {
   3.759148296481497*^9, 3.759148296637762*^9}, {3.7620634247037945`*^9, 
   3.7620634273114705`*^9}, {3.762063630488194*^9, 3.7620636311673703`*^9}, {
   3.7620652297702026`*^9, 3.762065231025529*^9}, 3.762066516612142*^9},
 CellLabel->"In[9]:=",ExpressionUUID->"53a7d916-c64a-47bb-9f84-835b25fc2bfc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["InterpolatingFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{
               GrayLevel[0.6], 
               AbsolutePointSize[5], 
               PointBox[{1, 1}], 
               PointBox[{2, 4}], 
               PointBox[{3, 2}], 
               PointBox[{4, 3}]}, {{}, {}, {
                AbsoluteThickness[1], 
                Opacity[1.], 
                LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                 "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
             GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
               GrayLevel[0.7], 
               Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}]}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{
               GrayLevel[0.6], 
               AbsolutePointSize[5], 
               PointBox[{1, 1}], 
               PointBox[{2, 4}], 
               PointBox[{3, 2}], 
               PointBox[{4, 3}]}, {{}, {}, {
                AbsoluteThickness[1], 
                Opacity[1.], 
                LineBox[CompressedData["
1:eJwBMQPO/CFib1JlAgAAADIAAAACAAAA4ScLwZmZ6T/ACPskWpOYv4AjHgZ5
3Os/cnpQh5xu1j/qWn1XCVDuP5K7ih5ptuc/r+pongFN8D/CUK87BHLxP46d
cUQ/bPE/ujUa8/qu9j9TbqBw1aPyP/TWyyAhFfw/neDJZqDG8z+QAqdF9GsA
QM1wGePDAfU/VsVD/9nXAkCidscSKDf2P6Bp73exDQVA/B1wDMFX9z+TpM3k
wfUGQDzjPoyykPg/7M3Z+O7ZCEABSgjW2LT5P3pl9LwNcgpAbCYw0z/T+j86
ypori9cLQL0gflb/Cfw/lpOs9xIqDUCTvMaj8yv9Pw4alcoYNg5AT3Y1d0Bm
/j+pB2LLtyIPQLClAv7Nmv8/NnA5bbjSD0BLO2UnSF0AQFrcILXmpw9AsTLc
klX5AED+sDHBQukOQNp6UGP9igFAbZ+lR/sLDkD10dd20SgCQNHi3Mj38wxA
42MO5MXDAkAZdr6AZb8LQJRGQrZUVANArv7zEMKHCkA4OInLD/EDQLBlMO3M
IglAnnrNRWWDBEA3d8OX6skHQNf3wBnbEgVAD3D3ndNyBkADhMcwfa4FQHOK
7Wak/wRA8WDLrLk/BkC/MhCgYawDQNJM4msi3QZAwss/TmVLAkCGc6iEq3cH
QIsIg92+BgFA/OprAs8HCECrPCvgePD/P2VxQsMepAhAKXVLE0Xg/j+RSBbp
CDYJQPRz0a7WJ/4/kFqZaBPFCUDN4sX5uLj9P4J7LytKYApAvh1MbRmT/T82
7cJSG/EKQHzT1YZwwv0/3W1pvRiOC0B2LZ/10lT+P0c/DY2wIAxAVrX8MJA7
/z+DS2C2aLAMQElWzbMzPQBAsmbGIk1MDUCi9bAadCABQKTSKfTL3Q1AYexd
q+EpAkCJTaAId3sOQFyS/ndEhgNAQAPGdkIWD0BHWcLdahwFQLoJ6Umopg9A
vd1CiejSBkCTjw8wnSEQQPiVkXD08QhAq0KpbbNqEEBsk2Azxi4LQCyTGthZ
shBAYCBYjj+gDUAnaxVkFgARQMwfdA9ySBBAg+uOIqBIEUBj/5rHgMsRQNFn
q5SZmRFAL++xNeOlE0Dwt3AR
                 "]]}}}, AspectRatio -> 1, Axes -> False, Background -> 
             GrayLevel[0.93], Frame -> True, FrameStyle -> Directive[
               GrayLevel[0.7], 
               Thickness[Tiny]], FrameTicks -> None, ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])]}, PlotRange -> {{0, 5}, {0, 5}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}]}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"6", ",", "3"}], "}"}], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Hermite\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["False", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  InterpolatingFunction[{{0., 1.}, {0., 1.}}, {
   5, 5, 1, {25, 25}, {7, 4}, 0, 0, 0, 0, Automatic, {}, {}, 
    False}, CompressedData["
1:eJxTTMoPSmViYGAAYUkGBAgFg6X2EHqrPUT0AJR/1H71KhA4BRW/AOVfgspf
hYrfgIrfgorfhYo/gPIfQuUfQcWfQMWfQsWfQcVfQMVfQsVfQcXfQMXfQsXf
QcU/2DMgA4f3diUszYeLnnLYN0k8nlKjIG8vvbGl1OKfof12jusucsym9uZ+
q+a6tVjb976zfnL/sIu996XsCr13gfYsDHarOyUS7f0r4ycU+BXa5/AJFrSJ
NdmfXnzJSch0sn1S4f+1NcYr7NmWqF+9ZrjL/obmFYPr24/aW6iHfzmmecF+
Xu/eKN0J1+xZvygfnPztjr2Z7lHh2nUP7TMTfrhtePjEfs5k7arHIi/szx+L
Wyvm8dqe+dfEB57VCH8AAJZXnOI=
   "], {Developer`PackedArrayForm, CompressedData["
1:eJwl1XP0EAYQB/D6Zdu2bdtYdovLLdu27WXbWnbL1rJtt0/r3vv8f+/uvu8S
NWxT6c/AgQIFah8Q6P8KQnBCEZYIRCYaMYlDfBKRlBSkJh0ZyUJ2cpGXAhSm
GCUpQ3kqUoXq1KIu9WlEE5rTijY/e6MTXelBb/oxkCEMZxRjmcBkpjGTOcxj
IUtYzirWsoHNbGMnu9nHQY5wnJOc4TyXuMoNbnGXBzzmGS95w3s+8ZUfBBhw
MEIShvBEIioxiE08EpKE5KQiLRnITDZykof8FKIoJShNOSpQmWrUpA71aMgf
NKMlPxfejo50oTu96MsABjOMkYxhPJOYygxmM5cFLGYZK1nDejaxlR3sYi8H
OMwxTnCac1zkCte5yR3u84invOA17/jIF74T2L0GJQShCUdEohCdWMQlAYlJ
RkrSkJ5MZCUHuclHQYpQnFKU5TcqUZUa1OZ3GtCYprSgNW3pQGe60ZM+9GcQ
QxnBaMYxkSlMZxZ/MZ9FLGUFq1nHRrawnb/Zw34OcZR/OMVZLnCZa/zLbe7x
kCc85xVv+cBnvgX8Cn8QghOKsEQgMtGISRzik4ikpCA16chIFrKTi7wUoDDF
KEkZylORKlSnFnWpTyOa0JxWtKE9nehKD3rTj4EMYTijGMsEJjONmcxhHgtZ
wnJWsZYNbGYbO9nNPg5yhOOc5AznucRVbnCLuzzgMc94yRve84mv/CAgqPwT
kjCEJxJRiUFs4pGQJCQnFWnJQGaykZM85KcQRSlBacpRgcpUoyZ1qEdD/qAZ
LfmTdnSkC93pRV8GMJhhjGQM45nEVGYwm7ksYDHLWMka1rOJrexgF3s5wGGO
cYLTnOMiV7jOTe5wn0c85QWvecdHvvCdwMHknxCEJhwRiUJ0YhGXBCQmGSlJ
Q3oykZUc5CYfBSlCcUpRlt+oRFVqUJvfaUBjmtKC1rSlA53pRk/60J9BDGUE
oxnHRKYwnVn8xXwWsZQVrGYdG9nCdv5mD/s5xFH+4RRnucBlrvEvt7nHQ57w
nFe85QOf+Rbs1+MPQnBCEZYIRCYaMYlDfBKRlBSkJh0ZyUJ2cpGXAhSmGCUp
Q3kqUoXq1KIu9WlEE5rTija0pxNd6UFv+jGQIQxnFGOZwGSmMZM5zGMhS1jO
Ktaygc1sYye72cdBjnCck5zhPJe4yg1ucZcHPOYZL3nDez7xlR8EhJB/QhKG
8EQiKjGITTwSkoTkpCItGchMNnKSh/wUoiglKE05KlCZ/wCo9jh4
    "], CompressedData["
1:eJxlm3c4l1Ebx5VRkUgoKytbqCSEg6zsRCoVRZmVIiMjhGRnK2Wv7L07NiF7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    "]}, {Automatic, Automatic}],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.7578426718583655`*^9, 3.757842711215823*^9}, {
   3.7578427468552933`*^9, 3.757842754346284*^9}, 3.757842806193059*^9, 
   3.7578429676979713`*^9, 3.757843652471919*^9, {3.757843701196867*^9, 
   3.7578437211591697`*^9}, {3.7578437536968145`*^9, 3.757843772658853*^9}, {
   3.7578438947202854`*^9, 3.757843977819366*^9}, 3.7591314508791456`*^9, {
   3.7591474165170317`*^9, 3.7591474487077355`*^9}, {3.759147488575042*^9, 
   3.759147505660438*^9}, 3.75914753657063*^9, 3.759147599496687*^9, 
   3.7591476819593077`*^9, {3.7591480295861454`*^9, 3.759148057519948*^9}, {
   3.7591481062625504`*^9, 3.7591481950868225`*^9}, {3.75914826419771*^9, 
   3.7591482971482725`*^9}, 3.7591483271795235`*^9, {3.759148360897584*^9, 
   3.7591483921341457`*^9}, {3.7591484495478587`*^9, 
   3.7591484776930666`*^9}, {3.7591485095391517`*^9, 3.759148566020262*^9}, 
   3.7591486400520487`*^9, {3.7591486916153092`*^9, 3.7591487117966285`*^9}, 
   3.759735786987938*^9, 3.759735860404012*^9, 3.76070066260427*^9, 
   3.7607631900427322`*^9, 3.7607633805000687`*^9, 3.762062987529349*^9, 
   3.76206305619615*^9, {3.7620634184081426`*^9, 3.7620634278966036`*^9}, 
   3.762063463500843*^9, 3.7620635633737593`*^9, {3.7620636270602865`*^9, 
   3.762063703867234*^9}, {3.7620637381871233`*^9, 3.7620637856704674`*^9}, {
   3.762063830829164*^9, 3.7620638487968264`*^9}, {3.762063879883893*^9, 
   3.7620638883460894`*^9}, {3.7620639681497974`*^9, 
   3.7620639978074937`*^9}, {3.7620640717986946`*^9, 3.762064078358397*^9}, {
   3.7620641968751526`*^9, 3.762064230047776*^9}, 3.76206432928351*^9, {
   3.7620643706742516`*^9, 3.7620644799606104`*^9}, {3.762064524952286*^9, 
   3.7620645758775005`*^9}, {3.7620646429279003`*^9, 3.7620646763095627`*^9}, 
   3.7620647126170034`*^9, 3.762064938370566*^9, 3.7620651479679556`*^9, 
   3.7620652395247145`*^9, 3.762065356264008*^9, {3.762065454742563*^9, 
   3.7620654794679785`*^9}, {3.7620665181935244`*^9, 3.762066545798688*^9}, {
   3.7620666099793434`*^9, 3.762066626681677*^9}, 3.8423279839882507`*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"af65fc20-ae20-4e98-90c2-3b204fd21f7b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"usol", "[", 
    RowBox[{"x", ",", "t"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7578422674439116`*^9, 3.757842304506777*^9}, {
   3.7578427156700244`*^9, 3.7578427304869437`*^9}, {3.757843735221928*^9, 
   3.7578437359411144`*^9}, {3.7578437746944113`*^9, 3.757843786334504*^9}, {
   3.757843822774189*^9, 3.757843823309329*^9}, {3.757843899262498*^9, 
   3.757843901910214*^9}, 3.759147466185713*^9, {3.7591484165900784`*^9, 
   3.7591484182854595`*^9}, {3.7620634353035445`*^9, 
   3.7620634364548264`*^9}, {3.7620638542242537`*^9, 
   3.7620638553355427`*^9}, {3.7620643346169133`*^9, 
   3.7620643380157776`*^9}, {3.762064503841827*^9, 3.7620645056723013`*^9}, {
   3.7620652418903475`*^9, 3.762065242840575*^9}, 3.7620654664586244`*^9, 
   3.762066528459208*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"44a0583c-a2cd-44e7-9ce9-f68627b26a34"],

Cell[BoxData[
 Graphics3DBox[{GraphicsComplex3DBox[CompressedData["
1:eJx1vXk8Vd37/4+oNM+paNQgQkpUsqXhRqMGSaJoUpkzlUSmMjvm+ZhFScic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    "], {{
      {RGBColor[0.880722, 0.611041, 0.142051], EdgeForm[None], Specularity[
        GrayLevel[1], 3], 
       StyleBox[GraphicsGroup3DBox[
         TagBox[{Polygon3DBox[CompressedData["
1:eJxFmXm8VlMbht/9rrWjOVOKkgaaS/OkqEga0DyXigZUEplSKEKkDBVCaaJS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            "]], Polygon3DBox[CompressedData["
1:eJwtmgfcl9Mbxp9zzvOWmRYSoVKkSFYDoYzSQIqkaZeRyIhQMvorIqOhVLTt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            "]], Polygon3DBox[CompressedData["
1:eJwt13n8VWMaAPD7u7dbUpbRpp02WhQqUSm0kRbt0kar9tKulXZtTKWaNiZt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            "]]},
          Annotation[#, "Charting`Private`Tag$2646#1"]& ]],
        Lighting->{{"Ambient", 
           RGBColor[0.30100577, 0.22414668499999998`, 0.090484535]}, {
          "Directional", 
           RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
           ImageScaled[{0, 2, 2}]}, {"Directional", 
           RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
           ImageScaled[{2, 2, 2}]}, {"Directional", 
           RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
           ImageScaled[{2, 0, 2}]}}]}, {}, {}, {}, {}}, {
      {GrayLevel[0], Line3DBox[CompressedData["
1:eJwt0jkvhUEUBuCxcy2XCIIgYikk/AJqgkoj6BSCgkrQ23pBL6FW8Asoaey7
e11bJSRCZXm+RPHOc6b4cs7MfPXDk30TaSGEeYkpojrbkuJRegjFTLKOb2zj
LztYlBFCL2s4xFa2ybi6m7Mc4BJHucZpbnKBO1zhHiszQ/hggd5HzI0GkSs5
Vl7zhDc85S3PeMdzJngRzcp7uVSnou/5wGs+8oZPvOUz7/jCBPed65OF9knm
RfchW2Y8tF/nLpe5zTlucIqrHOEi+znDLnbKmLqFg6xmT3ROtvNbz1a+spbl
7uGd+frGmcMfNrOITSxkIwvYwHzWM8Y65kVvwlxWsVJy1BXMZhmzWErtQgmN
E+I0RjiwfP3/D39DDz5G
        "]]}, 
      {GrayLevel[0.2], 
       Line3DBox[{723, 1037, 489, 722, 1166, 945, 724, 1167, 946, 725, 1168, 
        947, 726, 1169, 948, 727, 1170, 949, 728, 1171, 1058, 1265, 729, 1038,
         1051, 1373, 950, 730, 1040, 1052, 1374, 951, 731, 1042, 1053, 1375, 
        952, 732, 1160, 1172, 1054, 953, 733, 1162, 1173, 1055, 954, 734, 
        1164, 1174, 1056, 955, 735, 1371, 1045, 1057, 956, 1046}], 
       Line3DBox[{737, 1059, 1266, 736, 501, 738, 1175, 957, 739, 1176, 958, 
        740, 1177, 959, 741, 1178, 960, 742, 1179, 1060, 1267, 743, 1039, 
        1061, 1369, 744, 1041, 1180, 961, 745, 1043, 1181, 962, 746, 1161, 
        1182, 963, 747, 1163, 1183, 964, 748, 1370, 1044, 965, 749, 1372, 
        1047, 966, 750}], 
       Line3DBox[{752, 1062, 1268, 751, 1063, 1269, 753, 513, 754, 1184, 967, 
        755, 1185, 968, 756, 1186, 969, 757, 1187, 1064, 1270, 758, 1065, 
        1271, 759, 1066, 1272, 760, 1188, 970, 761, 1189, 971, 762, 1190, 972,
         763, 1191, 973, 764, 1192, 974, 765}], 
       Line3DBox[{767, 1067, 1273, 766, 1068, 1274, 768, 1069, 1275, 769, 529,
         770, 1193, 975, 771, 1194, 976, 772, 1195, 1070, 1276, 773, 1071, 
        1277, 774, 1072, 1278, 775, 1073, 1279, 776, 1196, 977, 777, 1197, 
        978, 778, 1198, 979, 779, 1199, 980, 780}], 
       Line3DBox[{782, 1074, 1280, 781, 1075, 1281, 783, 1076, 1282, 784, 
        1077, 1283, 785, 545, 786, 1200, 981, 787, 1201, 1078, 1284, 788, 
        1079, 1285, 789, 1080, 1286, 790, 1081, 1287, 791, 1082, 1288, 792, 
        1202, 982, 793, 1203, 983, 794, 1204, 984, 795}], 
       Line3DBox[{797, 1083, 1289, 796, 1084, 1290, 798, 1085, 1291, 799, 
        1086, 1292, 800, 1087, 1293, 801, 561, 802, 1205, 1088, 1294, 803, 
        1089, 1295, 804, 1090, 1296, 805, 1091, 1297, 806, 1092, 1298, 807, 
        1093, 1299, 808, 1206, 985, 809, 1207, 986, 810}], 
       Line3DBox[{814, 1208, 987, 812, 1209, 988, 816, 1210, 989, 818, 1211, 
        990, 820, 1212, 991, 822, 1213, 992, 824, 1214, 578, 826, 1215, 993, 
        828, 1216, 994, 830, 1217, 995, 832, 1218, 996, 834, 1219, 997, 836, 
        1220, 998, 838, 1222, 1000, 840}], 
       Line3DBox[{839, 999, 1221, 837, 1312, 1105, 835, 1311, 1104, 833, 1310,
         1103, 831, 1309, 1102, 829, 1308, 1101, 827, 1307, 1100, 825, 1306, 
        577, 823, 1305, 1099, 821, 1304, 1098, 819, 1303, 1097, 817, 1302, 
        1096, 815, 1301, 1095, 811, 1300, 1094, 813}], 
       Line3DBox[{842, 1106, 1313, 841, 1223, 1001, 843, 1224, 1002, 844, 
        1225, 1003, 845, 1226, 1004, 846, 1227, 1005, 847, 1228, 1107, 1314, 
        848, 594, 849, 1229, 1006, 850, 1230, 1007, 851, 1231, 1008, 852, 
        1232, 1009, 853, 1233, 1010, 854, 1234, 1011, 855}], 
       Line3DBox[{857, 1108, 1315, 856, 1109, 1316, 858, 1235, 1012, 859, 
        1236, 1013, 860, 1237, 1014, 861, 1238, 1015, 862, 1239, 1110, 1317, 
        863, 1111, 1318, 864, 610, 865, 1240, 1016, 866, 1241, 1017, 867, 
        1242, 1018, 868, 1243, 1019, 869, 1244, 1020, 870}], 
       Line3DBox[{872, 1112, 1319, 871, 1113, 1320, 873, 1114, 1321, 874, 
        1245, 1021, 875, 1246, 1022, 876, 1247, 1023, 877, 1248, 1115, 1322, 
        878, 1116, 1323, 879, 1117, 1324, 880, 626, 881, 1249, 1024, 882, 
        1250, 1025, 883, 1251, 1026, 884, 1252, 1027, 885}], 
       Line3DBox[{887, 1118, 1325, 886, 1119, 1326, 888, 1120, 1327, 889, 
        1121, 1328, 890, 1253, 1028, 891, 1254, 1029, 892, 1255, 1122, 1329, 
        893, 1123, 1330, 894, 1124, 1331, 895, 1125, 1332, 896, 642, 897, 
        1256, 1030, 898, 1257, 1031, 899, 1258, 1032, 900}], 
       Line3DBox[{902, 1126, 1333, 901, 1127, 1334, 903, 1128, 1335, 904, 
        1129, 1336, 905, 1130, 1337, 906, 1259, 1033, 907, 1260, 1131, 1338, 
        908, 1132, 1339, 909, 1133, 1340, 910, 1134, 1341, 911, 1135, 1342, 
        912, 658, 913, 1261, 1034, 914, 1262, 1035, 915}], 
       Line3DBox[{917, 1136, 1343, 916, 1137, 1344, 918, 1138, 1345, 919, 
        1139, 1346, 920, 1140, 1347, 921, 1141, 1348, 922, 1263, 1142, 1349, 
        923, 1143, 1350, 924, 1144, 1351, 925, 1145, 1352, 926, 1146, 1353, 
        927, 1147, 1354, 928, 674, 929, 1264, 1036, 930}], 
       Line3DBox[{944, 1050, 714, 943, 1368, 1159, 942, 1367, 1158, 941, 1366,
         1157, 940, 1365, 1156, 939, 1364, 1155, 938, 1363, 1154, 937, 1362, 
        1361, 1153, 936, 1360, 1152, 935, 1359, 1151, 934, 1358, 1150, 933, 
        1357, 1149, 932, 1356, 1148, 931, 1165, 1355, 1048, 1049}]}, 
      {GrayLevel[0.2], 
       Line3DBox[{271, 490, 1166, 272, 501, 296, 1269, 512, 311, 1274, 527, 
        326, 1281, 542, 341, 1290, 557, 356, 1301, 572, 1209, 371, 587, 1223, 
        386, 1316, 602, 401, 1320, 617, 416, 1326, 632, 431, 1334, 647, 446, 
        1344, 662, 461, 1356, 677, 476}], 
       Line3DBox[{273, 491, 1167, 274, 502, 1175, 297, 513, 312, 1275, 528, 
        327, 1282, 543, 342, 1291, 558, 357, 1302, 573, 1210, 372, 588, 1224, 
        387, 603, 1235, 402, 1321, 618, 417, 1327, 633, 432, 1335, 648, 447, 
        1345, 663, 462, 1357, 678, 477}], 
       Line3DBox[{275, 492, 1168, 276, 503, 1176, 298, 514, 1184, 313, 529, 
        328, 1283, 544, 343, 1292, 559, 358, 1303, 574, 1211, 373, 589, 1225, 
        388, 604, 1236, 403, 619, 1245, 418, 1328, 634, 433, 1336, 649, 448, 
        1346, 664, 463, 1358, 679, 478}], 
       Line3DBox[{277, 493, 1169, 278, 504, 1177, 299, 515, 1185, 314, 530, 
        1193, 329, 545, 344, 1293, 560, 359, 1304, 575, 1212, 374, 590, 1226, 
        389, 605, 1237, 404, 620, 1246, 419, 635, 1253, 434, 1337, 650, 449, 
        1347, 665, 464, 1359, 680, 479}], 
       Line3DBox[{279, 494, 1170, 280, 505, 1178, 300, 516, 1186, 315, 531, 
        1194, 330, 546, 1200, 345, 561, 360, 1305, 576, 1213, 375, 591, 1227, 
        390, 606, 1238, 405, 621, 1247, 420, 636, 1254, 435, 651, 1259, 450, 
        1348, 666, 465, 1360, 681, 480}], 
       Line3DBox[{281, 495, 1171, 283, 506, 1179, 301, 517, 1187, 316, 532, 
        1195, 331, 547, 1201, 346, 562, 1205, 361, 577, 1214, 376, 592, 1228, 
        391, 607, 1239, 406, 622, 1248, 421, 637, 1255, 436, 652, 1260, 451, 
        667, 1263, 466, 1361, 682, 481}], 
       Line3DBox[{285, 691, 497, 1373, 286, 692, 1369, 508, 303, 1271, 519, 
        318, 1277, 534, 333, 1285, 549, 348, 1295, 564, 363, 1307, 579, 1215, 
        378, 594, 393, 1318, 609, 408, 1323, 624, 423, 1330, 639, 438, 1339, 
        654, 453, 1350, 669, 468, 1363, 684, 483}], 
       Line3DBox[{287, 693, 498, 1374, 288, 694, 509, 1180, 304, 1272, 520, 
        319, 1278, 535, 334, 1286, 550, 349, 1296, 565, 364, 1308, 580, 1216, 
        379, 595, 1229, 394, 610, 409, 1324, 625, 424, 1331, 640, 439, 1340, 
        655, 454, 1351, 670, 469, 1364, 685, 484}], 
       Line3DBox[{289, 695, 499, 1375, 290, 696, 510, 1181, 305, 521, 1188, 
        320, 1279, 536, 335, 1287, 551, 350, 1297, 566, 365, 1309, 581, 1217, 
        380, 596, 1230, 395, 611, 1240, 410, 626, 425, 1332, 641, 440, 1341, 
        656, 455, 1352, 671, 470, 1365, 686, 485}], 
       Line3DBox[{291, 697, 698, 1172, 718, 699, 700, 1182, 306, 522, 1189, 
        321, 537, 1196, 336, 1288, 552, 351, 1298, 567, 366, 1310, 582, 1218, 
        381, 597, 1231, 396, 612, 1241, 411, 627, 1249, 426, 642, 441, 1342, 
        657, 456, 1353, 672, 471, 1366, 687, 486}], 
       Line3DBox[{292, 701, 702, 1173, 719, 703, 704, 1183, 307, 523, 1190, 
        322, 538, 1197, 337, 553, 1202, 352, 1299, 568, 367, 1311, 583, 1219, 
        382, 598, 1232, 397, 613, 1242, 412, 628, 1250, 427, 643, 1256, 442, 
        658, 457, 1354, 673, 472, 1367, 688, 487}], 
       Line3DBox[{293, 705, 706, 1174, 720, 707, 1370, 708, 308, 524, 1191, 
        323, 539, 1198, 338, 554, 1203, 353, 569, 1206, 368, 1312, 584, 1220, 
        383, 599, 1233, 398, 614, 1243, 413, 629, 1251, 428, 644, 1257, 443, 
        659, 1261, 458, 674, 473, 1368, 689, 488}], 
       Line3DBox[{294, 709, 1371, 710, 721, 711, 1372, 712, 309, 525, 1192, 
        324, 540, 1199, 339, 555, 1204, 354, 570, 1207, 369, 585, 1221, 1222, 
        384, 600, 1234, 399, 615, 1244, 414, 630, 1252, 429, 645, 1258, 444, 
        660, 1262, 459, 675, 1264, 474, 714, 715, 716}], 
       Line3DBox[{475, 676, 713, 1355, 460, 661, 1343, 445, 646, 1333, 430, 
        631, 1325, 415, 616, 1319, 400, 601, 1315, 385, 586, 1313, 370, 1208, 
        571, 1300, 355, 556, 1289, 340, 541, 1280, 325, 526, 1273, 310, 511, 
        1268, 295, 500, 1266, 270, 489, 690, 717}], 
       Line3DBox[{482, 683, 1362, 467, 668, 1349, 452, 653, 1338, 437, 638, 
        1329, 422, 623, 1322, 407, 608, 1317, 392, 593, 1314, 377, 578, 1306, 
        362, 563, 1294, 347, 548, 1284, 332, 533, 1276, 317, 518, 1270, 302, 
        507, 1267, 284, 496, 1265, 282}]}, {}, {}}},
    VertexNormals->CompressedData["
1:eJx0+3c01///P46LCqU0rYYkoYxKkpKrUkYoEtJAkRRSKKmMVMjIDBnZK3tv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     "]], {}},
  Axes->True,
  AxesLabel->{None, None, None},
  AxesOrigin->{Automatic, Automatic, Automatic},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGrids->None,
  FaceGridsStyle->Automatic,
  ImageSize->{409.93791759027516`, 168.24453193481747`},
  ImageSizeRaw->Automatic,
  Method->{"DefaultBoundaryStyle" -> Directive[
      GrayLevel[0.3]], 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "RotationControl" -> 
    "Globe"},
  PlotRange->{All, All, All},
  PlotRangePadding->{Automatic, Automatic, Automatic},
  Ticks->{Automatic, Automatic, Automatic},
  ViewPoint->{-1.4514272333347888`, 3.037466933335501, 0.3422771029845784},
  ViewVertical->{0.04361148457400392, -0.09126771171493656, 
   0.9948709681217816}]], "Output",
 CellChangeTimes->{
  3.762065243809845*^9, 3.762065358625641*^9, {3.762065458255494*^9, 
   3.7620654687402115`*^9}, {3.7620665204451337`*^9, 3.762066529152393*^9}, 
   3.762066628617198*^9, 3.8423279841052513`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"d52088be-d43c-4ac7-a7eb-c191c7a5e75f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{"usol", "[", 
    RowBox[{"x", ",", "t"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"FontSize", "\[Rule]", "22"}]}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<x\>\"", ",", "\"\<t\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"LabelStyle", "\[Rule]", 
    RowBox[{"FontSize", "\[Rule]", "18"}]}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", 
    RowBox[{"1", "/", "4"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.803196805105626*^9, 3.803196833671854*^9}, {
  3.8221187699439163`*^9, 3.822118798103809*^9}, {3.8221188409819508`*^9, 
  3.822118849846275*^9}, {3.8221188906385612`*^9, 3.822118945967553*^9}, {
  3.822118997785364*^9, 3.8221189980093403`*^9}, {3.8221190935879683`*^9, 
  3.822119099155077*^9}, {3.8221191550580907`*^9, 3.822119164708666*^9}, {
  3.8221192040279355`*^9, 3.8221192181558514`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"f4ee7e5a-3473-44fc-aae3-e693f22ab01b"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{
     GraphicsComplexBox[CompressedData["
1:eJyVfQVYVc0TN4iC8WJhJxYWii1YIyBiK6goBoqBiQEqBio2KBiICiJIiYFB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      "], {{{
         EdgeForm[], 
         RGBColor[0.148, 0.33, 0.54], 
         GraphicsGroupBox[{
           
           PolygonBox[{{1765, 720, 1763}, {2036, 121, 1669}, {2042, 136, 
            1757}, {1802, 121, 2036}, {1642, 166, 1816}, {1812, 151, 2055}, {
            1758, 714, 1756}, {2055, 151, 1764}, {1756, 714, 1803}, {1808, 
            136, 2042}, {1771, 724, 1769}, {1816, 166, 1770}, {1555, 432, 
            1804}, {1688, 166, 1642}, {1769, 724, 1813}, {1670, 432, 1555}, {
            1763, 720, 1809}, {2038, 1020, 2037}}], 
           
           PolygonBox[{{1809, 720, 136, 1808}, {1804, 432, 1020, 2038}, {1669,
             121, 432, 1670}, {1757, 136, 714, 1758}, {1770, 166, 724, 
            1771}, {1813, 724, 151, 1812}, {1764, 151, 720, 1765}, {1803, 714,
             121, 1802}}]}]}, {
         EdgeForm[], 
         RGBColor[
         0.24973867713062303`, 0.3865214872947906, 0.635279078582647], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxNVT1IllEUvt/fvV9qUWpGbdkitDZUoEThIDi5VotL0FCLLW5Bfw65BbnU
EhgJfoho2R+p6WKLhWbQZwWZ0q9mJuJQz+PzBA2Xe99zz7nnOec857z728+3
ncuGEO5g5bDymRCqsH7h/BiCdVw247sFawqrF/IzMYRG7O2FECqKIbyGzjfI
6lIINyEvQjaXlQ31N3Ceycr+A/Re4PwuSo/6izj34G4S8kPYh4Jsh4Nsmv1O
PfB0QKfOetzPQt7mt2nD+37qY72JenMO+3Zg64TuepIe8fF9xleVh55taEu9
gajzceg3FpSP51jd0L+NNY+7Tdx1QfY+Cg+xnMTqxXcZ3wewT2eEjz5XjJ1+
SvBZsq+rWelQdw37H8Q5ktE6nJGPTcguZGXTVBCmUbzRZZzV2C8WjS8KX8Ba
xbaclT1t152Ha9D5HpWHfZDV4r0arEXozUI+CvkovsewDsKunISZtSMm5utY
RvWLBeEeMX5+8454fzregbzk1GGta/zuIOSz5hh1V6w/59odTapRsSCdeznF
QwzER5w3kmSZguT09TIrDIyHvliXpZzipKzOvlizaexDOekTD31NGmOtcU7g
fhJrIoi7zMOOpHimjGdnUvy7kuynjWEG+s9wTkmxsl/IZ/phbP9ySczM50xB
OqWkvuKZsoWoNz9ifxSFi/Whf+blsHtl1u9/ieq7z9ivQ68P53FyI8qmHFVT
5q1krjGuLvfdjOtS4fxWkieux27s95N6qBK8K2Y0O8i54aRcPUh6e9m8/RQV
Y00SR8nVu9F5zemtBnIur/4h3nrX6lRU7quK4g/7jTXt+28evEmaS2ccN+cX
8bNX2DPsBfZxo8/sH57Z1yXzldyj/wbrsNcXMuon8qHHfomDeEbg85ZjYf99
jcr/HsivRL15GfuJpNl0yTkgR7vMSfKx1X1EObnQ7RlTdk7z7mVia3Lvb9Ut
r7rxnjV4FTQLOBM4w6o9ozbNPfKbHCPf18zPJud81fmfty/mtcM5YR8Q60Fz
hH45R56Yh+Qj+cz3mz37iP00+ZZk+zapD9izrf7XsB70xbhHPOtKnsWdnu0b
nu+ci1OeM7+T+rcqiTus4ZDzM27+8Mw8bfHGOXplvpJrP6JsqUP7h+Yt+cs3
xmy75JqRv9EcI9fIjf7/+MHclf3f4rvEw3/LtHucOguu57JnL2fwoP8/rMuR
JI499b+jxf/DrTg8f/Ym9fc2xPEXC4ciIQ==
            "]], 
           PolygonBox[CompressedData["
1:eJwlkjcsxlEUxd/3/3hPj942VoPFQmJhNZlZjBIsLGZ1YJOwMBISJjWIEhYW
Ei1BCKImSpRg4Hdyh5OcW94t79ySprb61sg5Vw4SQFpw7hXHG8jxznWBdnhp
3LmWROfi2HXkreM7hPeBTuzpmHP98AXeb5M7h28efoGvH75L/iX8DOzA/8j5
IX6NvYedRvOQBPCtYVfzxgebQbN0gB74Bqig1zb2CfyUnLu4zaTZGtWD+Cb1
BqiXRfyD3Flyroi9Y//CX/ClBJtBsygnE35PzjL2AfYjfIidx+CDYBQ7mZrj
9DrSe/gpvsm47XSu3tQoi9lM5/BVfCMx863AH7zV/gaFwf5UfzuFPZBoPsXq
QTO5m95i2lm75xH/imxGzdrNm+nIZtSsVcH+Rj0r4anBdtWMmlU1VbsXDMNn
gu1yCJ6wc7D3I9MsG14MjiPbuQheE0xr3UQtvCDY22Hi+fBnb9rrzQv81ltM
Ne/0n8FuRxofeNNc2munXGIZwW5FN5UOXwRbzm5qKZim0la+Bu3v7TakqbSV
xtJaN3UD/8DX7OymP+ET3rTUjYzD/wHwInXX
            "]]}]}, {
         EdgeForm[], 
         RGBColor[
         0.4552152161691256, 0.46368585871758405`, 0.5514709272360412], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxFVktonkUU/R7/N5NU/7QqmCh1oS6EggkpuIhVyEMTSEyTuBCVaLULqYiP
VYO4qiio0ETEFvyLWbZBjZUoVaPpIqkmStNAavu31fqMaMQSoSVEsdVzPKe4
GO797szcOXPuY74btz9971NZkiTLGDlGf5ok32GcgH4OEzMYvdB7YLuySJIx
6GuwXQG9E7bz0DPoLdD3Qz+CMYg1OyE3YozBPgp5C5w/YfumXHN3R+nPYH8H
vjdj9NnPtM99r5QkxzL555nrfO7XIUlmYT8D+Rvkm/CzKdU8181CH4f9Ztjr
IZ8sdP4LWP8Dxjxs30NOptLpfxFr2iEvAle50H278V1X6LvbHJTNQxNkI0al
9P/ch7BfgL93cuGewFyK0Yb5+6P8L5ovzr+C9b2p9n2Osds4iXd3TZJswZqH
gnzUw/YG5n7F93HYf4H8EWMB+jHMtWZaTw7vwFkVyC1RXHA9MTxgDMTyAfbe
xLOxN4P/hkLnDGDtcCo+J7FuDnf5GPKeoLjdBf0P6Kehr0C2+Uzi5zmHcp1F
vA3mtNaxI37em3F9zvqCeSCf+0rKA0ry+pVzgDk2AT+3YbzlHOP507m4p51x
JneLqeZop69W46MP+iL37ZlwM88HnD+7YJ8zbmJmHImPOJkjb+fa2xGVz+2Q
00F4ZiAvYN9Z2Bei8n6j915VEofVVDiq5orxYQ5fvhMl8ZOrrlQ5Ng85k6v+
yiXxO+s8pySfXeaX+irmYyH+t2Kc8lnEtYS5RuiHHHfGnzx0mB/W+n7X3QHr
g87PRecocRy3vqEknjnHMyec5zfk2s+9zZnOIM9DQXmVOZ+5nnFv8xpiYP/h
NzEztn85jo3uEfSX2c9ByGcLcfQIOH8+1R3/y2nmPfZ/xDyP4vD9qLpccFwZ
5zlzuAwse92D2DPYp5hPpx1fxpmc17r/DAbVGmuUGOvcH9gbqB91XRHLP1j7
cFScTjIHo84dco/pMZ/vYl0FvsaDzh51Po/m6nGsx9GgmthTKL7kiXvJJXsZ
+UxKyld+087YTPo8nvtgVF3Wu95XfBZzti8Tj8RNvPPOw1dd++wBXLPP68q+
K9d0Og/HjI84XyzEa6u5/R37p3Cfg1Fx7vdbw9oeMgb2/pFUeXhdFL/XQx4I
8jUGeTJoTR40qH8TdddV3/3lIJ8vmc+d9l8EvW01UfXxZS4czC/mGXFuy/UO
0s4+RHuzeaq3n3WI/XrM1daoXzX5LSBe2snLiaD47cFZIzXqKeujcpc53By1
d9l9b9z+2QtmCtVkNShuXc5V+u0055eievffkC1RtXd7VD9jzrCnbcjV46iz
Z7TZD99x9hTaWCusY9b6o4X23BqFlZj/jOp/5/1Wsoexp/X6nRh2vCruxaz9
Ec/RTv/sFzyD/wgVr+FbveaetuScYo8i9p/dk5OouUtB9xpwLbCfE8+E+1y/
64H1xxgcdS4t58IyFdSXDgf9N7D33hmFqds1eF+u/tbj3O8xz3zTVv2Gfhvl
82xULhM/47GE73P4/glym+uddV81r8T2WqEztsP+OvRB6I9B31so53ZEnb/V
eBr8NvM9OhyVq1NRvefye0Ifp7wnRHEXo3J/xblKLvucA+SfOBmDa6Pw10Ne
zLWHfK5FvV0jQW8mbfzmuXzPqq6XdvfkzVFxedz/VC3uRZ/C/gX8fgI5XCi/
Pwvikb2HeZj5H4nrr47i+RrI+UK5x7ohJ/TDOxLLmPEw/sRN2y73L/Yu+kjc
E1m7Ta7rctSeOsh/ATihZYk=
            "]], 
           PolygonBox[CompressedData["
1:eJwtlElIFVAUhu97z3fva7DMoIlaVIsgKChoURaETYuwaREkhimURWStlIgW
QjRBFlEuFIw2Gc1RaIMK6QstMhemKWU22GBkBknZZH0/p8WB/z/n3nPvOee/
d3r+7g2FUedcNpaCnQ3OXYo5N4izJe7cLXgTPCviXDU46Z1bAG4i/gycwNcP
zmJvEbweq4JPY89CYj3wi+AWfK/Af7EZ7O/VocQ/wxuId8G/gOfgS4OXsKYG
/g6rhrcR/wB+o/PgSXiS+3XD++AN8Ab4S29nqZhfxCbBj0Jb8b0Gv/eWK5V4
IuFcLfwcvFHG/i72vCXfR7gHP8eOR+yMF+DHcculHqlXP4L1ah9nDIHHYF+j
VrNqz4CXR+zOveBD+IqIz4QXkuseNjtiZ3QQOwjvAecSLwOn4xtgfTF2BLwf
XxvxjcRPxq1m1a4a7hI/7G3tH+LfOe8MvI9aK7AS6m3F101sLvfdRayD/avI
14xdC3Yn3e0yOUrBefhWE2vEdzNYDuV6wv5K9vdjj4iPxTeS2IiE4Z/snxys
x+r1EHwCfDR8HDwDnsPebfhyyL2GHFvVa2+9nEr8BDifO1SA12IF8N+siabY
TDXbLfCWiNWQC96jfsasx+r1KM5LSzEN1wTriXqjGaUG04i08g2eDu5kTw6u
C/Au8KJgWpZPsc3e7r5UMwQvCfYWNOPF4KtYHetXwtu5y/JgtehOK8BTgvVG
mpf2G72dtZP8x+I2E82mHN8VbzPVbPWm6rzlVG71XL2/721WepN6m3oTyf96
kLZPc15lzDQmremN6q2WwouVn/iDmGlK2soOpoVMbJPmja8zYjM6BR729nal
oUH4vGC51uObDz5PvCxqmpP2CvCtI/6Q9fXgG8G0pJntZf+At7evGWlWdcHW
6kydHYK9RdXQ7k0j0oruXAu+rfvGTFPSlv4o/VXy3QHv8HY3/Sl55JsYTIua
0SdvmpK29Ob19vODvS1pXtrfHuwtqgbVoplr9qqxCnzA2+xmsWaZtBWsd9Lo
MPipt79Ff2QcPD6Y1vSn6W/LDLa3Et91b3+e/j79kdXefIrpD9Bf8A+YLdF6

            "]]}]}, {
         EdgeForm[], 
         RGBColor[0.6665645357434695, 0.5379619774178328, 0.427227237773807], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxFVktslkUU/f5+/8z8LmShMekGKommYKzEx8IgIiQqi6JJqxCpKZRW5CFF
NpRIagySiBGDVIkGykZdtVZipUKFAiVCLCmtCxvqYyFtMRKasBAXPqB4Ts9p
WEzufHfua+499843t/H12i1lWZZNYeVYk/g4hLWrkGUdYJzHfgArxCxrA28U
9AToQqw9kH8RMp2g32I1pSxbDv7PIct6QBuKkumCfju+N2M/Dl4tdA5iPwe0
Cvx67PfAbjnkloGeBP0MawHjgs0cOjdBPzd/caa41oA/G/QurK32sQm+58Lu
YsgvTeLvhM1J8K5iPQ/dGnw3QXdzKctWQeY58OuSeGuLir0RevsKysMinN0L
mSeTYn6wIDt7oX8NcneAv6GkeNaDtoK3Gvvugu7Dez0FmdNR9z2HGK9jTYB/
E7xt4I35vjui/BZB+6J8nYVsPfwO4HwUay1srcB3I+gXWL3Yf8ncg1Y7t/32
RZ814I0hnvZM96jIlXPmY45zUperhgOuS4Xv+S7iegBrBPvLsDFRVM0ZL+Nu
xuqEj0/w3QGau/asO3F0T656/Y34prD/JykW4oBxFsBrgXxFJnw1GXu/wM4Q
zvohfyyq9lXYP5Jk8+EkG7TF+40YNyEJX+R1wGYxKa9bcD6YK3+8Y2WZ7sZ7
JePjEmQ/ht+LOH8HNMP375C5xVqUac87R/cI70W8M2+dzttVY3pVLh/LnbcV
jmc8SeY30A/hoxe8N0GXJWH52aR+I3aaM2GF9sbA/y6oJtO4wLofdh8qCR/k
T0BmP/jvQ28T+G9hXQL/vihcLwrqycqgPeX2ReH1A9A/k3y+h/0frjPv9lHQ
fV5hLXL1I2fA5SScPAE6GNQL7Ikm7O8GfwH4u6P6fit423E2zFpHUeam0xgo
y4Ul9uJyY3gN9F/AvsF4ZzzM1zXPJMbK/i537/8aNWvORp1zRrRCZj98fw+6
M2h+nHLtqDMvV3zMR6XzcwXrZftijxLrjO2s7Z+LkmGO2DfUZX6Zz6vmTWMs
qDfZk/Tb5x4/bXyyH4tBPcN5ypkxP1ftDxQVS7W/B3yXW0l+WGfGPt/xd/su
zAnxW2+sTxYVE797nEfOjy1BeqwPZVbnytGRgvBAe2P2zziPg87yDKnw3OAM
oR5t0yf9txu3h2F3JfMWJTPpGC5gDWP9ZNwzxyeS+mql88x5UDAehqxz3rNv
0Lo7XdOTSWeD+e2+HincnmXcz5xfsC5nAevwH+juoB5hr7AW0/fHWV8SBtZ5
bjEnPOM8YkyzIP9GUE8fSXqD2v2WsY97bIf9csLz8Ewu3BPz435Hy92bDX53
ys2/YezXem4Qs9G4Je+Ue4Q+y90Lr5Vka2NJso2epY8l7bdFYZO4ZX7aomLl
7OFc55yiL+KRuWj1Ozvb2GN8ufm9QfOWc7e1pDfi7SA7Nf4n4JvH2JYkzcvo
ePg+b/W7zfpQlzUiNi977gTHwL4gDa4NZyH1mOeFjoe5rfYbd9Dzgf8uA36b
+X0d9Jmkfnna/ynECvPwaZKt4SDfzE+v36Ndfuu/SardDsi8FBUz781v8jnb
qMv78+7MwWnngTlnDxKvXyXV7mIQvurcdzXWZf77/M4sMH4H/H/FGd/meOpt
k2eMcZ/5/fbLPj3kOBkvc9dtTC5FrI9Dd0lJc4bzdo8xRj7rtM74fzUJY13O
+Z0l1aodNk8l9fb6pN4adJ8Sn+PGAW0f8By5ETVL/43Soe4G0L2eRZxJ26P+
AVqieuKA/yE5G1r8v8F3j/OB/wycJexf9vXcpHekKioHZ5x/+u51ThjPMd+X
97vieb02qLc2Rsket3yX5y3nbrNn2g/G0TzP5iHjlDjiu9dorM+8tTP+K/3m
/hVU3ynYO5zk68egek7O4MT/gY8m4fGKMTkaVOOvk+Zxv+Nscd5KSXTSvXbU
/078hyraJm3/D7ZqkW4=
            "]], 
           PolygonBox[CompressedData["
1:eJwtlElIllEUhu8/ffffVNAAbUqFIgoHGhbRIAnVyoKMIhs0/aM0s9yYGBHU
KirSBorKRdTKShvUtJyJiCgNCrR0kVptklpkiwa1npfj4uV7z3nPd8+995xz
UwqP5BwOO+d2gyhY6p2bE3GuBuf9wLn3Mee6sTvBQ7RufDPR0kLOdcHTQBgt
BJLRy4g/xDqLsTdgv8VuhmeDHdjFxGc6y7EM+yP4Ch8FHq0fXGDtVPCMfz95
40non+FvwHbyl+P7iV4BrrNeB/oDtHfYT+Et4C72clBNbCH/rIDvBVvRavmn
kthK8m12FnMM/g1facjOlELsX3wZ6MP8Pw7/gJ6N3gua0G+CWmK/o79Cew1e
hs0n7Ql2B/Yt0KS7AqPwBKiAdxLzmtgeMEDsTuxNETuTzlZFzHFiJ/H9Qot7
+1d3FEM7CcqwU9APEj8fe3rU7qCe2OfY98JWk/PoE/giUauJajOO3Roy36S3
GqvWXaAfPdPb2qq5ar8WOxl7D+sNYOdh50TsTvPh673VPo/1stGL484VwBNg
S2A9ol5ZiJ2KvQ87N2J3moBXER8j7yrsHr5niCkl11zyn4U342ubus/GwPag
veiMg/B13mJ1J1nwa/hOwxeBE/xbh300ZD1Ur7uK292/ZI1p8DpvvXNOa8Jv
BKYtIb4GXh5YL80iJsF6p2KmKYdyKYdy6UyX4CX4kvj/Kr478Efe7lY1Uq0y
vK0VoKd7mznNnnpEvfInsN77BMZYb8xbr+lOfsALwTb1O/ZF9NnEN3K+eeoR
3QdnWhm1HlQvKodyyZeFNuRt9jQDmoUi7DzsPuwrxLd6W3sXvjZvPay7bwct
MauB7NvgMXy1t1lVj6yB//bWuw3saQb8HzFfwlZD1XIysFmWz6G3gxfO9tAB
b/A2qzpjIzzmLbdmMgo/FLfe0pl1dr0xems0Q7nw9Lj1mmqgWgySszdiM6fZ
S/O2d71JBWjD3t42vUkj3npYvawZrIbv93YX2uNl4g+wfn7UZl6znxTY26A3
U2+nzqyzq6fV2xOB1VJvjN6aBdhDIduT9nYwbr2nmSmB907NgmZ0hNiN3mqr
nEXofTF7+zSDmsX/FWrDCw==
            "]]}]}, {
         EdgeForm[], 
         RGBColor[0.8779138553178136, 0.6122380961180814, 0.3029835483115728], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxFV2tolmUYfr/3+94DlFHiRlZ43HRu8wCV+ssDWiyhck7TSi10ks2YZQZT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            "]], 
           PolygonBox[CompressedData["
1:eJwllV1olmUYx+/3ffc+9xNpyKjRitRtbm5tfkCpZ36QZSdF+6oV24Q5yUy2
osSPtqbTPmw2qo0CdaBnzpmGULSdtIMliEdrQmxIpZAmSEGjDnRr/f78Dy6e
/3VfX/d9P//rukvaOus6siGEd5AC5Mc8wsJZ5IckhDfSEErBbRjfBFfGEH7B
L+ZCqALvwr8Y3I7Pfvwrom0X0S+jX8c+A76RCaEcfRVyH9zIWgm+vdjHyNdH
/i7y/4N+G9stJIN9DP8IXkHMKHgTshh9N1KL/zX0/djKkO+JfYqYIuoPYf8G
2zr0RVnvcT14DWsF4BxSir5XOYNjnkbfnDpXIfoW8J/k7Mw4pgx7O9KU854H
sK0gvhb7APvvwf8++k3qNSEd4DXRuVRjB/4vsrYM2/vII4nvWHc9jIyDh5BP
wTXIUfwfQ99K/jHyHyN/o+4Y2wfIcvBJpA9ciH0x9l707dRqQG9Bb1UMeJAc
KbYS5Bj+lcjL4CZkOuMcpxLnVO5ypAH8FfJh1jW72E8p+nFwNfIq+CfxgfOt
peYk+Dj1xqn3HTnrsa9l7eGc/6H+5QnkE3AVcoh8U8gz+F5BLuC7DVmFfzf2
z/F9JbGv9qy9b018tnqkmVqb8C/HvwV9G7bXEt+d9qi9ioPiojgoLipGsbqT
Z7HdQ97N+J/NgX8j307wAGsRvR69GH09eh34S9aOio/iO/nGWZvJmAMz6Lei
ff9iT7fBL6Xmqji4UWcXX8H3sP+NfU/qs6rHanW3yIGsa3aSryjxXYozX4AX
iClg76PEnwe/jc/SrGMUOxud+xwxD4CfQ2pyvlPd7UOpuaI9a+/TxE/kzOkd
6BujudjK/9yN7b28uaAz6+ziuLg+jf2jvHtWvSsOiUuvo2/IuOau1JwVd/vx
L8Z+OHHuCvUXtX6Nvuu76DfBE8gkeI56j0f3sHr5LlIAnoqeBeLcNfCN6FjN
LM2uIuo9Sr159JX4H2RtJPiM30b3nHpPd/aC+hP/CvyX47MHfXP03sQpcasn
715RD6gXcqz9kfVM0GxQT6m3NJO6E+dQrgXViOakuKl/3gf+OO9ZqB5Xrz+Z
2Pc/5An8l6E/j72HmH3iTurZ24t9ULmiuaeZ0AyuS3y36jn13qXoXlKOn6n1
VuLe1EzNRudQLnFIXBJHxJWAb3/qO9ZdqwcOgucTz2r1yKzuIvG/0R3rrofR
O9TrrJ0Dfx3NTfX0SPQZdBb9A/0LvRF6KzQT2vOekZqVd7Qn/FenzqU3ogbb
kbxnjWaGZsfv0b2lGfegZil6yJkz4o7eDL0d+kf/EnsGn8+yfrNO6/1JzY0l
6DWpz6yzi7NX+eaj96I3RW+L/on+jWpUJ34z9HaIM6vR/wel1Ne2
            "]]}]}, {
         EdgeForm[], 
         RGBColor[0.9302337340083319, 0.6955843350208297, 0.3837245754258288], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxNmG2QlmUVx+/n5X7B7IM5iYmWGy9ZgNjEprgYLPuKhiIvu7GioVnTjIzs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            "]], 
           PolygonBox[CompressedData["
1:eJwllUmMVVUQhs+7791zb8IKiEzdEQmjNNgkyNjMQtNABHqibWkIIBASEtvH
EIEWuhliGCKTdu9QZhoTIRBNBA3oloXI4IqFJgbYsgHBSOL3519UUv/5q07V
rVNVd9i69oaPkxBCGSkhH+Qh9BRCeB/Qiv59GsJNDI4UQziYhdAQQxgO3o90
o+9Dyuin8OmDvhufL/B9BG4Fn0GOwf8NHoVe5I4W8KfgF9z9D9KmBJCJ8JOQ
SKwUGYHtS/iOgs9GggfAdybOoRF9NGfj0XP4t9HnE7+mZB/5jsXmX/QmbN6E
Xw5fC39Sd8I9R/oRfiL8C/TD8D/DfwO/CDwm8936htPgDvhD8Lfw6VJtkNtw
55Ef4WvhZ8LPhe8A7wQfAF8Bf4Ztde5c/uP+d+AbuX8e97fDt8N/C14M7gZf
Rv8d2YXtX5w9RH+QWVdMxb6D9ILnIvVwZ5Ea7K+Cz6NPQSrQK5Gpug/7a+i/
YlNB/HOZbX8Bb4ebz1n/xG+6ilx74evgvyKfS+htsoEbwTeNg38DGYj+BP/R
+K4Br8W2hbO16O2ctWL/Gn41vns4Ow73GzYHwBty13olZxvRP8H+Q+z/JOY9
4q1J3Ru6Q3eNzx37FT6V8AvAM0queQ38Kr0xvl/jtgPfx5l78xlnTzP3lHqr
Cvt3sT+C/62S+39xdE+oNxZyVp+7pqqt3qgB/Sj8W+TyHTZ90bdgU8b2B81M
dE7KTTVRbQ6m/tZucBd4SbSvYir2/tS9pJnR7JwA9wT3QARvRbbBdXK2Ba4u
Olf1qHr1eOpe0RuVwM9Tz5ZqmJDLsdRvVwufwM9DppU8I9O5awd4L/pdzQj4
o9xvpx2wLncPq5enc/YeeBJ3Dip6hmbBtSB/FDwTmo1dyOcln62Au5C519ST
d8llofiC36wOvTk6tmZEs9KZelZ0h+4ain914hmuwvYi+LpqA18Z/YZ6S+2Q
svLJvbvquWMOeFp07vpmfbt6XL2+F/sv4Q5l3m03wK/Ue9G7Sz2qXu1I3Uuq
kWolG9lqZ7xEf5K5tzSDmsXZ0b2jmdPsDQR3Je6ZZdExFXsYsi31m+pttdNO
wm0Czwmu8WT8JyAXEp+th2vM/W2LiNGEvhJ+WdE934Z+P/PsaGdod4zSzi54
R2pXrsZnc+IZXxDdk+pN2YzUvoueZdW8AvvmzL2jmt9LXXPVPkUKuXeedp9y
vIE+BLmN/0/aV9gvjZ4N9bB6uZx612lmNDvrc8++dkYtttXRu1H/iOGa5eha
qYaqpf45+vcoxmD0Ju38oneadtuK3LVRjzWjh9y5yka2E6J3kf5p+rdpJ2o3
qia7o3NW7qqpavs/GObN5w==
            "]]}]}, {
         EdgeForm[], 
         RGBColor[
         0.9639956061448086, 0.7799890153620215, 0.48838637904890647`], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxFmGmQVdURx99y77sXJmJZkDIw7GhAk1iIODDDMhabwzKiKAlTiSkZcIZB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            "]], 
           PolygonBox[CompressedData["
1:eJwtlVlsVlUUhe//3//ecxkEiRq1g9AiChiNlQhCEVGg1BYsViviwKQWS6G1
LfOooAZFQJwoggqUSU3UBMVnSZg0EdF39cEHISgtBsFEE7/l8mEle+29zz7T
Hsrmtta35KMo6gQFMDmLonEI81D+nUTRedCWi6Jh6CqwPQOeQO7A3jeNotHw
CvgI1o6ErwELsPUH45H/Yf0G1k/Cpw7fV+BTsf0QR9Gx4D20Vy32BuzH0RXj
Px+cQF6Ebim2L+F1xCuH3wA/D+/Afnfq2BPBA9gmgieJl4Ex2GrgEzjbeOy1
yJNAr7zvWI38SOa9+6GrR55KzNGcbS84wdnWwX9hfR/4euSt+DSgb2b/r+F3
Zr77rcQYiXxXZllvNgp5CVgFHwsv5jwt8Gfh5ayZSZxXibGJ2JvBF/BZ+FTl
fccyfJdj/4O1ZfCh2f93LPhOY/HdBFbgXwxqkKPMex0BOeT16NqxXQOqkO9I
/ZdDwe3YB4OByJOxz8Z2c+a9quFzUv+x/roI3J9aJ1s5PsPwfQrMQL4a3Szk
x0F9wX+uv5+A/wBsSrLeyMOD37IvuAW5OnVs3UF3ucSa5To7vA0+BZ9R+HaB
49iKiF9E/DP4NGP7Bp8/ka8Cn2JfrDfDvo6nWCSOT3fOd7wR2+zEbz8f3pr5
zrr7IPgQeAf29sg5p9xbm/rsD8LvRZ6WOhe1h/ZSDMXSmUdguylzrAvwpew9
DdzD2Q+Ak8ReAtZHzgnlxhiwOucaqkTeiL0xcg6eZe0e8AnyZ+AUtip8GvPO
4Ur224quD2uPEqMU/jq8F7w3SPCdrv1z9kmV7/BxOfsU4HtZ8yaxFhN/V+I1
Wvs5/EN8Pwg++2XQH9/HsE8r+I/vg78bXCsXQD94g2qS+AF7XrVIzKaca161
/yv2nth/qr/doztga4JvTxxDseRzBvtCcFa1Q7wS9Q/4z/gPRLchuIeol2wA
LyIfBd/H9rlMrJg1GWsP6Q+wdaF7A1srfCf7bUl8VvnItxm+i9it+DyPb1dw
LukP9iK/FLyXelQ18mqwNnYOKhfXwl+Ad7PmY2LthFfG/tMdyO/rfeDz4O8h
zwdzY/eYbfh/FPz2+jP93f7gWtabnsZ+MPgu+kP95UX2/JGz/gQuIS8J/kvl
vHK/Jfht9YZ6y/34vJ33mQ8Sbx/8LfhK3S9xDMXSG+otVwTb1IPUi75NfbfD
+JxS/0/da5WTE3i/zfCVedfQf7UU/Na/sb4N+SQoybmHqpcOBKUF9zz1vm7s
f8WuGdXO7+BS7DerU79N3RvU44fAH2J9TcEzR7NHPVy9XLqHkR9Vz0ReqJrB
Pj3zbJJuRuaaVm0rp5Xb6onqjYM5fwW2qZlnh2p0SuY76C468yB4cebcnETM
makhuQRdKbbt+O/G/zZwLPEZdBb1zLmaZZl9zynngnNOuaee2YT/05l7t2Zu
o86XOvc1QzRLalP3fr35AOSXg2en3vgQ62frDQqeAZoF6tHq1dLNQb4SXVPk
N+9RfbBmWeycUG4cgK+JnTPKHfVc9d5GdAuQX0ucy8rxc8E9Xb1dPfp64ncm
9lWNq9Z3wBfErkHVou6su0v3XPBM12xvhy8K7jnqPcqB8+pHiW3qWepd6rHq
tTrzMuRrM89m1dR1yKdT52oPZ/wu9QzRLNGfXAF/J/hvdqPrRN4WLKsHqBd8
FTxbVNNHkIdnnn0X0a0Mntma3epxZxPnjHJnC7qN2A8nljXjNeu1Rmv1pquQ
9wX3ds0EzYZ/AYheE4Q=
            "]]}]}, {
         EdgeForm[], 
         RGBColor[0.9977574782812852, 0.864393695703213, 0.5930481826719842], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxNmHvQVlUVxs97Oe854agolihimqJgk8AnH1rhNNpN8NYA8gUIKBc18VMM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            "]], 
           PolygonBox[CompressedData["
1:eJwllmlsV1UQxd+//753nxgVEKO4IIsg4FJbpEVFjfBBSlmMwbVitRVttZYl
RA0BQVGQNSrEtlKwVIsLbmndEmPcEm0xCC6IUnelFKhAAU3UBP2dnA+TnLmz
3HfvnTnzBpXPvLYmJ4qi1UguUppE0XHZKJrC4p3gvXEUVWSi6BbkJfAx5Gr8
3sT5sTSKyvEpxvc67D9iOxSiaBR4E9IDrmOtE/8Z5KxG/wL/d/AfgH0reA5y
K3oWKQT/jX8ZeBz5J5H/IHopeh56Efpd6KuIbSDfGvLNZm0mtjzWTiB+JPoC
bH3RR4ArWJtI/A3oPxO7kJiHsU9HfxD8KJKHfgrf+Aj4GaQ54zO0438H8SXE
34T+K3oBOXfr/KyNSn0GneVt9G3gt/AZiH4MWRF8Z7q7/kgL+FWkFd8WZAv+
VfjskZ0znEa+12PnrkM2Yz8f+4l83wXsWYbtW/SN2BYR8y/6pcQU5PrOdHfF
6L3AV7FWAu6NDCO2H3ofcCc+txF7PbIB/BT5GsnfhHyCfjl7Hk98FTIV/z2s
3Y7vjUgTeGLq3JXY5+PbxVo5tpv15rqfxGfXm+XjW0L+0eRei7yHfQhrfbDP
RT8HvI61Lr7vHvRZ+O5H3wH+GmlDryTfNTl+c739GcScBK7EfiZ4BvZJ2EtZ
+x37i7Gxala1+wEyHLwSeZJ8nyd+q+3Ef6z3xr6P/Wejz0X/MvFdN+LzlWpH
9YytA+nB92XW6rF1ID3gs3XH5K7BPhD8Gf7fgXchh/BfjhRGzjEW+xLsy7I+
o866SDUIPozPK+hHE/deGTl3o/8U+61Uw6rl88gxhPuvIKYWW4a1c7FPID4S
Tl3787APBz+Pz4HIPTFftY8sBS9Hlgbvqb2XoD+Efjg2/h7Zin4FOQpzfYYi
8k9O3ZuqMdXanOCz6w0biB2Q+i31RmeBFxLTG99a9F7gvqnvRjWp2rwvuBb0
Bo3ET0HPx/dP1rrBg1O/je54EHhE4l7Snenu+qWubfXkyeCR6peMz7gYPC/4
LrqxP6f3QxZnzUHbybUf+1H0ZmQduB35BpyPFAfXiGpFnLGZ2DGpuSiH+ItT
c6C4cCh7/hebU8Qt2/D/CNzN2s6sc25B/zDYJg4QF+xC78y6R9QrekO9pdY6
9C3Ib1n3gHphFvtVs980fKqI/wP7X9g3IevB96oncs1B+7BPZu0i8BHdMXhl
7LtVjGJXxLbpDnQXO4K5RXvuBD+NNGWcow3fYeS/P+seHgquDf4WcUhdcE2p
tlSjqtVLUnO7OOoy8Lux72oZskr1lriXNHM0ezbG5mpxjrhHb6C3UM+0xu5B
9aJ6TL32eHBvqwfex7Y+9iwSx4nrxFHiKnHaWHC17JFnhmZHV/Ds0Bn3gj8N
5h7NhAngBcgbOe6hF4htScwN4uBWcHPs2SAOFBf+EpsrNTM0O9YGzypx0BPg
DcFvVYA+VW8bmzvFYeKy+mAu1jfqW39ApmU8Y49grwnmPs3UemzjE/eWakK1
0Z6YOxTTBv5HMw9chP1K7GMSY/W0ent67NmnmlHtPBu7V/TGD4gvg7lAM0iz
6EDwt2tGHlTvJn5L7aG97g7mJs00zTbNMM0ycaa4czR7XJjrma/ZrxmoWag7
fk3cnXr2iDPGYWsI7k1xgrjh9NT/Eurx/uDVwbNF/yT6N1FPqje1RyH41NSz
VT2oXvwffgslcQ==
            "]]}]}, {
         EdgeForm[], 
         RGBColor[1., 0.95, 0.75], 
         GraphicsGroupBox[{
           PolygonBox[CompressedData["
1:eJxFlUtsVVUUhk9v9znnzmiVIlMm0AKDi5jeWkw7l6RQpwys+Bxpoo4JzkyJ
plDrA9rCLbRAW5MWh8ToEGN0oPERFfXWChJjKLRE0KT4f66fdLCz1lln7fX4
12NvO/zKUy9Xsiy7otOq83mZZa+2ZNmtPMuu6dyQbEJ0SudP8ddFZ3Vuir8h
+ofOX+KnRSetz70xGRsQ3ZkFPWD+spwdFP+afGzKg98mfi2Fzqpom+hgvvF/
0PovFFnWq/uHitDD7uOy+TS68re7jO/t0u0R3V8G/4PoOelvFb/LOZBLI48c
yOWi6HHpnZSdd0R/1/dV+VqTr/Y8Yvq7JfyQA/EMOj7iXM7D/vPSXxL/iPjn
xL8v/Xd1euWjX/fqOtfFfycfS5J/I3pFeouSfyaaix7R3bp0TujfKel8Knv3
Jduss0Pyn/XdIf6w9Lutj/xXybeIf1by0yn4Lsn7KqHfKf7jPDABm0aKOlEX
YhxznCOix1sjhlHz4AkdMT+egsfmnRT5YufNapYNi1/PQ/+E7YwZB+oD9tS7
y7Uadr3eKkP/ch6yUfvqqwYuPUV8U3vsTIiupIilzXXYLfkneeA+Ins/6hyT
rawI/+85hg+cK/1wyH11u4j/6KMz6LpTa2rfZvvN1vBF386ksIUd/rdbnz5C
vs91pwbU6m6KXgT70TL+v0h9nTP43dO/i2nD9knHCj1lnjvcfUkxb0nRH8s6
8+LXU8QJNqeNDzUCc7Cfsw4+VnX/J8V1VfYWKsHTK+dTxDFjPXjmZCpFDsT/
dRGz8FURtvFBDzATyMGHvrhjv8zTovufWV+zPtgs2O8522enLFqO/nJrzAs2
54uYhTnRj4qQXSpiZ7G7nhSuK+bZZ7esz71aJXBiXv7Nw+730vmijLrdluwf
nWek97rzWnWvNh3DPvdP03zNvcf3bIpveHwy7/iip7a7ry6kwJd98aH3ytEy
bNTcY+wyds2XZWDQZxyg/ebr3hfMR939ha9u63e61th/0A/MDDt60nyHZ5Xe
e7uMWs+77uyVbtsBt1QJTJkl8mkpov/A4NsycsBXl2RnU/QK9X9MdG+K+2Bf
sx2+a475iWroDPvtYJ7o80vez7OuCfmyT4YqYTe5b8iFONl97L1f8ogfWd07
bdx1pEZNz+eE5+N/rNwnC3ng2W9M4XuNebvi7GDfiM747eMNJA7iJ68jzm2H
/eKTvcV7AB5N72lmosuzMOC3j7mc8/yC31nPwpDxx/ZWzycY3TXO6IDNkHXO
ePapNfSM34Ne50Oe49YhBmo+67qfN8U+8zjtXiW+Hsf8hmtN/3J3T77R+3vc
wyPe/Z3OpeF5X/LsMLcDrveDfT7pmKe9J8mrYX6Xc1mxDvcaloPrlO0T/wXv
qzbX66FqxDVvbO85T3T6q9FbzP3D1dinm013erfurQb/qO3UnO+654W54e0H
p9/y6PP73jMzxpZ++w9cty/Y
            "]], 
           PolygonBox[CompressedData["
1:eJwtkstLlVEUxc/N73zfnYmWj6kTIYcaJFY0d9g/4AN0WJD+A1kWWJmPMFG8
VHJFcaI21MqZCubAqKS0h92IkCg1aNCgfovVYMNeZ+21zj777LrOK5cunwgh
NBMJUZ4PoZQLoQpQQb4aQ5gsC2GCGM5C6E1D6EBwltouuBz4NvUP4J+BT6Gp
Tuwhr7do6nOueUfeQ307+igP8vuZvc/hN0r+i7M9uK/gCfwq8+5FfpvwQ8Q4
9S3w3dF36u4x4l5mjbQteHTjNYS+grPf6K/B94OL+H2nZibaQ1564wj8Nppl
tOXgNrg54gf8LJqbaHeoKcHV4feE2luczSWuWaL2Ffx+mWv+gC/An0n8Zr29
D1wAV6F/D9+ZOt+FPyZvRX8V3ETNeWo3OfsLbgA3gQeiOXnKuzFvTjM/Sf4I
/oBeqtF8JF9K3ave9DL1DDVL3fET/gaaabQ14H3w6dSzmudsMfrNenstZyXw
dfBD8DfuKIC3Ms+qB/4F+YJ2IOee1Xsxeta6Q3fJU96amWZ3lPqvpDkkX4Ef
xW9AHuSfonvTmx6Tv868K5rxG/LBzLXasafwa3gs4LdIrJNvpM61U1+id1a7
O4L+Ltrm1Luonb5IP5+j36od0a5op7Rb2rnncMvR2mHiTuZQrp7V+4fo2WtG
mtVU/D+rxH+/F/3X6lG9HkXPTjuqXf0Hqx+Bgw==
            "]]}]}}, {{}, 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwl0TcvQHEUhvG/QdnUL2CUmBgYlJ3NapDoEwN2nYjOJCEhIdESZVQ3RBmI
EqL3TZtI8BPDk+c97zn35iY3ubi6oCoihFCHpJgQYhGPOCRgJzqEl8gQtvmV
8zhL3yFnc01UCBnIkTM5lz/tauUy7nK/xJ28zD9od/PN3boVzudTnCF4LgKr
+h7zGvdyOffzOvfxIAZQYa50fyQf4xBfuhNe1C/gAPso0qfq97CLt793+5YG
eVau5xR383KbfoGn8IxJtOruuMzNLbeYJ/gJ42g233Cp/TWP4RGjuEKJ/pKb
3I3wA4bRaL7gYvt3nMsbvIkt3Js/eIjLuRBveMUMpjFnt8Pp3pWGxJj///kL
Pj5K7w==
            "]]}, "0.04`"], Annotation[#, 0.04, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwV0stTjmEYB+DHghoz1E6SlEOojZqUDha0UVTGkiHs0vmEdDIok9q06aCT
UQ4zTC3QHjMqTeS/oFIsLcx0vYtrfs/9e+5vvvc7pN6su1S7LYTwnrfbQ1jZ
EcIPlvnONz7HhPDGXZfs5BMfmdF9dT8rl2SH7rXzS+dXst3cRnpsCMe5oT8q
j9Gqv8e0vRf6KXnXfIc090e4rj8kD9Oiv80ze9P6SdlsbuKg+1Qq9AdkCg36
RsbsTelHZb25jmT3+7mm3yeTqNHXMmLvuX5YVpurSHS/l4zos/CQBzwmQz9k
95ZzJQnmPaxH3415wHlRFvNO1yPX5IKc5xzdPOILve6uUuN1q/IDT/Rzsk9m
erYT7rJkptzU58pTZJPDSRrd55DnXEA+/+xekKUUc54S2u0VUuZ8WpbL/3av
yLPmy/KM7GInRdTrKu3cd66SQ55tmMHoc5hHZLVssLfLznz03rqf/GK37qlc
0JfKVfqc1+Ro9LtRxjr9+t9ynAnK2WCTuOi/IBftXJR/+Eu8fgsxzl0R
            "]]}, "0.02`"], Annotation[#, 0.02, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwVzzsvA1AYxvFT1SKxmAwYJOwSDFjEpW4DqWpZqLoskjaiukgsFpe4xTdw
Z/YVzPgwbonB7wz//J/nzXvOyeksVbLlRAhhC0l8pUP4xDdeG0L44V8cyYd4
SYXQo5cbQ1iWK3IxWu+N5+Rt7kOX/X7ujveYj9kZ1Ed4gEd5jzM8xOM8iQn8
2V/gPLLIYR779oZRkJewiCa9xGtYwSqKOIh3Y13exAaa9Skcx7f4FNM40We4
BWfY8X7VbFZuxRx29ar5Vcx841+3uMabfsc1rtlrs/Mu58yCnkC72b3+Ef/G
dWbncpIf9EfkUa9fmKf4SX9GAWn90rzDPf8jnDDA
            "]]}, "0"], Annotation[#, 0, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwV0LkvRFEYhvEzxJKoSexb7GtjqWgoiZmxBEMhCoUYS2MnKEhUEiQSCf8F
alGoLFNq0emo/W7x5Pne93z33NxbPZdOLMVCCLtI5YTQmh9CG8ryQijkhtwQ
iriRS3WPqESLXM7NXMGL3GGvnWvkDq7lH3dm8x/H+JezeNn5K7/hBRm848H5
nbN7PKBTN69bNy9wt9yFPnnE+3I5zv3co+/Fjjkfs/pBTvEAz/ABF+DT3je+
8OzeOCeQRFo+tbPCq54ZMhdiGGvyqv4s+i9I4lSX4HMU40Qu4Yy9afelMIN1
+UK/FX2PnVFzFcawIW/rL817vCmPm6sxET0j7+uvzIe8I09G/xpT2JWP9Nfm
Y96X68wf5ieu9/4GNKERN7rbqMc/Kaw21g==
            "]]}, 
          RowBox[{"-", "0.02`"}]], Annotation[#, -0.02, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwV0D0oBGAcx/FH3TkGJjOujJyBmbMwM5md4tCZJJeIRVFKLGKweg2lmO4M
JjbK2+Blt7jNS3ye4dv39395nqee9NDkQKEqhJDHUjKE+ZoQWqpDeJZLqRCe
uMz1+nXYMtvGIGbVi+ab8hyvY9huDo/yGRd52l6TnQf5RO+eT7lR74hv1ft8
iAP8YcNszLlx5NGvnuAGXkOfnV6M6o3gxh076mteVdfKFXxi2f5KPINudRY9
WIhv2O+SL+UySrjSe9N7xwtSeq88w0UkcIwOvU5MyTln2uVMvNv7WVzEPzA7
5ztOmiVQkL/xgy9UzH/5g9PmbXIzt3Im/gHvYRf/ZvA7Jw==
            "]]}, 
          RowBox[{"-", "0.04`"}]], Annotation[#, -0.04, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwVz7EuA1AUBuBDUrpZrR7AoGvZ2EwdBANtkyqDMrUxdLCwqYjYPQBt0kYH
ZVEjEgMJG32EDiSqPsOX/z/nnuVO5XcypZGIWOIgEXHG5nhEkVtu2Lc7ZUMv
0OGaqt0JeT1HiyZ7dlm5zhov5oasyFW5wjLP5oH85YfJsYgPHu3PzQ+yloyY
0L/5oub9mEXmzQvsujs0l+QR93qXd96YczNLmh6fdN11vN3JV5kgaV+WFUap
M2OXYkvPuZ3W2/oVLdp2Qxn//5B985O+rV9ywR/9fDRk
            "]]}, 
          RowBox[{"-", "0.06`"}]], Annotation[#, -0.06, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           LineBox[CompressedData["
1:eJwV0K9OgmEUB+DDnICCBNxw2BhXoVGryayFYgKuwU02DUYqRGjO4h+cbuA1
4HRT1KIEFJvB4vOFZ+ec3/n2vu++Sq2520hFxA61xYiDdMRTJiJNhrG5rQ7t
HvQLPJsnvDCS38huuWNDtsljcg4j7jn1XZ0j/bb9Fuf6Iicc8ytbocCr+Z03
/sxFVvkwT/kkm40oydaYmc+S97rjS79st0RZts637Ic5Ofml7IoLBlyTl+8l
b1X31So9+nQ5lHeS/+GOFv/JaC0W
            "]]}, 
          RowBox[{"-", "0.08`"}]], Annotation[#, -0.08, "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Directive[
            GrayLevel[0], 
            Opacity[0.5], 
            CapForm["Butt"]], 
           
           LineBox[{1688, 1642, 1816, 1770, 1771, 1769, 1813, 1812, 2055, 
            1764, 1765, 1763, 1809, 1808, 2042, 1757, 1758, 1756, 1803, 1802, 
            2036, 1669, 1670, 1555, 1804, 2038, 2037}]}, 
          RowBox[{"-", "0.1`"}]], 
         Annotation[#, -0.1, "Tooltip"]& ], {}, {}}}], {}}, {
    DisplayFunction -> Identity, DisplayFunction -> Identity, 
     Ticks -> {Automatic, Automatic}, AxesOrigin -> {0., 0.}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, AxesLabel -> {None, None}, FrameLabel -> {{
        FormBox["\"t\"", TraditionalForm], None}, {
        FormBox["\"x\"", TraditionalForm], None}}, DisplayFunction -> 
     Identity, AspectRatio -> NCache[
       Rational[1, 4], 0.25], AxesLabel -> {None, None}, 
     BaseStyle -> (FontSize -> 22), DisplayFunction :> Identity, Frame -> 
     True, FrameLabel -> {{
        FormBox["\"t\"", TraditionalForm], None}, {
        FormBox["\"x\"", TraditionalForm], None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], LabelStyle -> (FontSize -> 18), 
     Method -> {
      "DefaultBoundaryStyle" -> Automatic, 
       "DefaultGraphicsInteraction" -> {
        "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
         "Effects" -> {
          "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
           "Droplines" -> {
            "freeformCursorMode" -> True, 
             "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
       "GridLinesInFront" -> True}, PlotRange -> {{0, 1}, {0, 1}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           GraphicsBox[{
             
             RasterBox[{{{0.148, 0.33, 0.54}, {0.24973867713062298`, 
              0.3865214872947906, 0.635279078582647}, {0.45521521616912564`, 
              0.4636858587175841, 0.5514709272360412}, {0.6665645357434695, 
              0.5379619774178328, 0.427227237773807}, {0.8779138553178136, 
              0.6122380961180814, 0.3029835483115728}, {0.9302337340083319, 
              0.6955843350208297, 0.3837245754258289}, {0.9639956061448086, 
              0.7799890153620215, 0.48838637904890647`}, {0.9977574782812852, 
              0.864393695703213, 0.5930481826719842}, {1., 0.95, 
              0.75}}}, {{-180, 
                Rational[-15, 2]}, {180, 
                Rational[15, 2]}}], {Antialiasing -> False, 
              AbsoluteThickness[0.1], 
              Directive[
               Opacity[0.3], 
               GrayLevel[0]], 
              LineBox[
               NCache[{{180, 
                  Rational[-15, 2]}, {-180, 
                  Rational[-15, 2]}, {-180, 
                  Rational[15, 2]}, {180, 
                  Rational[15, 2]}, {180, 
                  Rational[-15, 2]}}, {{
                 180, -7.5}, {-180, -7.5}, {-180, 7.5}, {180, 7.5}, {
                 180, -7.5}}]]}, {
              CapForm[None], {{
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{-140., 
                    Rational[-15, 2]}, {-140., 
                    Rational[15, 2]}}, {{-140., -7.5}, {-140., 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{-100., 
                    Rational[-15, 2]}, {-100., 
                    Rational[15, 2]}}, {{-100., -7.5}, {-100., 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{-60., 
                    Rational[-15, 2]}, {-60., 
                    Rational[15, 2]}}, {{-60., -7.5}, {-60., 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{-20., 
                    Rational[-15, 2]}, {-20., 
                    Rational[15, 2]}}, {{-20., -7.5}, {-20., 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{19.999999999999993`, 
                    Rational[-15, 2]}, {19.999999999999993`, 
                    Rational[15, 2]}}, {{19.999999999999993`, -7.5}, {
                  19.999999999999993`, 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{59.999999999999986`, 
                    Rational[-15, 2]}, {59.999999999999986`, 
                    Rational[15, 2]}}, {{59.999999999999986`, -7.5}, {
                  59.999999999999986`, 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{100., 
                    Rational[-15, 2]}, {100., 
                    Rational[15, 2]}}, {{100., -7.5}, {100., 7.5}}]]}, {
                Directive[
                 GrayLevel[0], 
                 Opacity[0.5], 
                 CapForm["Butt"]], 
                CapForm["Butt"], 
                LineBox[
                 NCache[{{140., 
                    Rational[-15, 2]}, {140., 
                    Rational[15, 2]}}, {{140., -7.5}, {140., 7.5}}]]}}}, 
             StyleBox[{Antialiasing -> False, 
               StyleBox[
                
                LineBox[{{-180.00000000000003`, -7.5}, {
                 180.00000000000003`, -7.5}}], 
                Directive[
                 AbsoluteThickness[0.2], 
                 Opacity[0.3], 
                 GrayLevel[0]], StripOnInput -> False], 
               StyleBox[
                StyleBox[{{
                   StyleBox[
                    LineBox[{{{-140., -7.5}, 
                    
                    Offset[{
                    0, -4.}, {-140., -7.5}]}, {{-100.00000000000003`, -7.5}, 
                    
                    Offset[{
                    0, -4.}, {-100.00000000000003`, -7.5}]}, {{-60., -7.5}, 
                    Offset[{0, -4.}, {-60., -7.5}]}, {{-20., -7.5}, 
                    Offset[{0, -4.}, {-20., -7.5}]}, {{
                    19.99999999999999, -7.5}, 
                    Offset[{0, -4.}, {19.99999999999999, -7.5}]}, {{
                    59.99999999999998, -7.5}, 
                    Offset[{0, -4.}, {59.99999999999998, -7.5}]}, {{
                    100., -7.5}, 
                    Offset[{0, -4.}, {100., -7.5}]}, {{140., -7.5}, 
                    Offset[{0, -4.}, {140., -7.5}]}}], 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], StripOnInput -> False]}, 
                  StyleBox[
                   StyleBox[{{
                    StyleBox[{
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.10\"", -0.1, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {-140., -7.5}], {0., 1.}, Automatic, {1,
                     0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.08\"", -0.08, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {-100.00000000000003`, -7.5}], {0., 1.},
                     Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.06\"", -0.06, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {-60., -7.5}], {0., 1.}, Automatic, {1, 
                    0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.04\"", -0.04, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {-20., -7.5}], {0., 1.}, Automatic, {1, 
                    0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"-0.02\"", -0.02, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {19.99999999999999, -7.5}], {0., 1.}, 
                    Automatic, {1, 0}], 
                    InsetBox[
                    FormBox["0", TraditionalForm], 
                    Offset[{0., -7.}, {59.99999999999998, -7.5}], {0., 1.}, 
                    Automatic, {1, 0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.02\"", 0.02, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {100., -7.5}], {0., 1.}, Automatic, {1, 
                    0}], 
                    InsetBox[
                    FormBox[
                    TagBox[
                    InterpretationBox["\"0.04\"", 0.04, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}]& ], TraditionalForm], 
                    Offset[{0., -7.}, {140., -7.5}], {0., 1.}, Automatic, {1, 
                    0}]}, 
                    Directive[
                    AbsoluteThickness[0.2], 
                    GrayLevel[0.4]], {
                    Directive[
                    Opacity[1], FontSize -> 18]}, StripOnInput -> 
                    False]}, {}}, {
                    Directive[
                    Opacity[1], FontSize -> 18]}, StripOnInput -> False], 
                   "GraphicsLabel", StripOnInput -> False]}, "GraphicsTicks", 
                 StripOnInput -> False], {
                 Directive[
                  AbsoluteThickness[0.2], 
                  GrayLevel[0.4]]}, StripOnInput -> False]}, "GraphicsAxes", 
              StripOnInput -> False]}, PlotRangePadding -> Scaled[0.02], 
            PlotRange -> All, Frame -> True, 
            FrameTicks -> {{True, False}, {False, False}}, FrameStyle -> 
            Opacity[0], FrameTicksStyle -> Opacity[0], 
            ImageSize -> {360, Automatic}, BaseStyle -> {}], Alignment -> 
           Left, AppearanceElements -> None, ImageMargins -> {{5, 5}, {5, 5}},
            ImageSizeAction -> "ResizeToFit"], LineIndent -> 0, StripOnInput -> 
          False], {FontSize -> 18, FontFamily -> "Arial"}, Background -> 
         Automatic, StripOnInput -> False], TraditionalForm]}, "BarLegend", 
      DisplayFunction -> (#& ), 
      InterpretationFunction :> (RowBox[{"BarLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{
                 RowBox[{"Blend", "[", 
                   RowBox[{"\"M10DefaultDensityGradient\"", ",", "#1"}], 
                   "]"}], "&"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.10195801309881496`"}], ",", 
                   "0.04613803974411814`"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.1`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.08`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.06`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.04`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"-", "0.02`"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.02`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{"0.04`", ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    GrayLevel[0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> GrayLevel[0.], FrameTicks -> None, 
                    PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"GrayLevel", "[", "0", "]"}], NumberMarks -> 
                    False]], Appearance -> None, BaseStyle -> {}, 
                    BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    GrayLevel[0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["GrayLevelColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    GrayLevel[0], Editable -> False, Selectable -> False], 
                    ",", 
                    RowBox[{"Opacity", "[", "0.5`", "]"}], ",", 
                    RowBox[{"CapForm", "[", "\"Butt\"", "]"}]}], "]"}]}], 
                 "}"}]}], "}"}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Row\""}], ",", 
           RowBox[{"LegendMarkerSize", "\[Rule]", "360"}], ",", 
           RowBox[{"Charting`TickAnnotations", "\[Rule]", "None"}], ",", 
           RowBox[{"ScalingFunctions", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"Identity", ",", "Identity"}], "}"}]}], ",", 
           RowBox[{"Charting`TickSide", "\[Rule]", "Right"}], ",", 
           RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}]}], "]"}]& )], 
     TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}, {
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "Below"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.8031968102981653`*^9, 3.8031968344365435`*^9}, 
   3.803208409878622*^9, 3.819524255455845*^9, 3.8221188061230235`*^9, 
   3.8221188504596353`*^9, {3.822118896866062*^9, 3.8221189468858356`*^9}, 
   3.82211899933862*^9, 3.822119165521962*^9, {3.8221192089745207`*^9, 
   3.8221192188828735`*^9}, {3.842327021364967*^9, 3.842327035538276*^9}, 
   3.842327984670282*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"03074443-804d-4508-832a-00c2aba65122"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"Table", "[", 
   RowBox[{"i", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "1", ",", 
      RowBox[{"1", "/", "10"}]}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.8195240881397395`*^9, 3.8195240985858946`*^9}, {
  3.8413755347511587`*^9, 3.841375553564588*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"ad4aedb7-1e10-42bf-b24b-82f908103fec"],

Cell[BoxData["11"], "Output",
 CellChangeTimes->{
  3.819524099087945*^9, 3.8195242557299204`*^9, {3.8413755395997005`*^9, 
   3.841375554107587*^9}, {3.8423270215472956`*^9, 3.8423270356162634`*^9}, 
   3.8423279848252544`*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"68077022-1d32-4790-9f9e-c42206aa8c53"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "10"}], ",", 
   RowBox[{"gridres", "<", "110"}], ",", 
   RowBox[{"gridres", "+=", "10"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "1", ",", 
         RowBox[{"1", "/", "gridres"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"usol", "[", 
        RowBox[{"x", ",", "t"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "grid"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<KdV_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.8423267602593713`*^9, 3.8423268583373256`*^9}, {
   3.8423269415164843`*^9, 3.8423269462944584`*^9}, 3.842327032805205*^9, {
   3.842327967141261*^9, 3.8423279709602604`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"15cf2864-a788-41e0-9188-eaca0c0a188e"]
},
WindowSize->{1920, 997},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 1011, 28, 28, "Input",ExpressionUUID->"05fe114f-2e97-4336-8c91-25a6faad9606"],
Cell[1594, 52, 1062, 35, 36, "Output",ExpressionUUID->"12c66b72-71f4-4222-b4ef-1e57f5ffcb9c"]
}, Open  ]],
Cell[2671, 90, 674, 19, 28, "Input",ExpressionUUID->"4dd8ad5a-5571-4848-b895-7143003f1c98"],
Cell[CellGroupData[{
Cell[3370, 113, 956, 28, 28, "Input",ExpressionUUID->"67bc938c-5a76-4381-95e5-8b69c82c6727"],
Cell[4329, 143, 768, 24, 32, "Output",ExpressionUUID->"7beb0a4c-b0fe-4cb8-a9a2-17e9f38a68b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5134, 172, 956, 28, 28, "Input",ExpressionUUID->"33a8a6ee-52c9-4d21-9ddc-a089614b0896"],
Cell[6093, 202, 765, 25, 32, "Output",ExpressionUUID->"3b2c054f-a999-4bb8-a4f4-9b12c55ed55e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6895, 232, 689, 19, 28, "Input",ExpressionUUID->"c6777c41-1163-4efd-882a-c0137430c7d5"],
Cell[7587, 253, 579, 17, 32, "Output",ExpressionUUID->"99c14594-e8bd-4fac-85fc-9646df150c1a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8203, 275, 2270, 33, 28, "Input",ExpressionUUID->"9e589859-453d-4860-8f81-475891e17d49"],
Cell[10476, 310, 2169, 67, 36, "Output",ExpressionUUID->"52db2240-a8b9-479f-8ad1-91dfa5b24d18"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12682, 382, 175, 2, 28, "Input",ExpressionUUID->"c76a3740-7723-4cb8-be19-726e2b8030c7"],
Cell[12860, 386, 563, 17, 32, "Output",ExpressionUUID->"cff52420-edc0-478d-9244-a2a4b0af3940"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13460, 408, 1628, 25, 28, "Input",ExpressionUUID->"7da20787-52c3-4bad-b963-ec44d4166781"],
Cell[15091, 435, 2030, 30, 32, "Output",ExpressionUUID->"4d13341e-ba83-4262-96f5-c04871fcf7a0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17158, 470, 1310, 24, 28, "Input",ExpressionUUID->"53a7d916-c64a-47bb-9f84-835b25fc2bfc"],
Cell[18471, 496, 26217, 462, 71, "Output",ExpressionUUID->"af65fc20-ae20-4e98-90c2-3b204fd21f7b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44725, 963, 1106, 21, 28, "Input",ExpressionUUID->"44a0583c-a2cd-44e7-9ce9-f68627b26a34"],
Cell[45834, 986, 88243, 1445, 185, "Output",ExpressionUUID->"d52088be-d43c-4ac7-a7eb-c191c7a5e75f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134114, 2436, 1194, 25, 28, "Input",ExpressionUUID->"f4ee7e5a-3473-44fc-aae3-e693f22ab01b"],
Cell[135311, 2463, 90789, 1698, 387, "Output",ExpressionUUID->"03074443-804d-4508-832a-00c2aba65122"]
}, Open  ]],
Cell[CellGroupData[{
Cell[226137, 4166, 414, 9, 28, "Input",ExpressionUUID->"ad4aedb7-1e10-42bf-b24b-82f908103fec"],
Cell[226554, 4177, 307, 5, 32, "Output",ExpressionUUID->"68077022-1d32-4790-9f9e-c42206aa8c53"]
}, Open  ]],
Cell[226876, 4185, 1439, 35, 105, "Input",ExpressionUUID->"15cf2864-a788-41e0-9188-eaca0c0a188e"]
}
]
*)

